
theory LRNormalisationProtocolIntegerProof
imports LRFWCompilationProof
begin



lemma ConcAssoc: "Cp((A \<oplus> B) \<oplus> D) = Cp(A \<oplus> (B \<oplus> D))"
apply (simp add: Cp.simps)
done


lemma aux26a[simp]: "twoNetsDistinct a b c d \<Longrightarrow> 
             dom (Cp (AllowPortFromTo a b p)) \<inter> dom (Cp (DenyAllFromTo c d)) = {}"
by (auto simp: PLemmas twoNetsDistinct_def netsDistinct_def) auto


lemma wp2_aux[rule_format]: "wellformed_policy2Pr (xs @ [x]) \<longrightarrow> 
                             wellformed_policy2Pr xs"
apply (induct xs, simp_all)
apply (case_tac "a", simp_all)
done

lemma Cdom2: "x \<in> dom(Cp a) \<Longrightarrow> Cp (a \<oplus> b) x = (Cp a) x"
by (auto simp: Cp.simps)

lemma wp2Conc[rule_format]: "wellformed_policy2Pr (x#xs) \<Longrightarrow> wellformed_policy2Pr xs"
by (case_tac "x",simp_all)

lemma DAimpliesMR_E[rule_format]: "DenyAll \<in> set p \<longrightarrow>
                                   (\<exists> r. matching_rulePr x p = Some r)"
apply (induct p)
apply simp_all
apply (simp_all add: Cp.simps)
done



lemma DAimplieMR[rule_format]: "DenyAll \<in> set p \<Longrightarrow> matching_rulePr x p \<noteq> None"
by (auto intro: DAimpliesMR_E)

lemma MRList1[rule_format]: "x \<in> dom (Cp a) \<Longrightarrow> matching_rulePr x (a#b) = Some a"
apply simp
done

(*
lemma MRList2: "x \<in> dom (Cp a) \<Longrightarrow> matching_rulePr x (c@b@[a]) = Some a"
by (simp add: matching_rulePr_def)

lemma MRList3: "x \<notin> dom (Cp xa) \<Longrightarrow>
            matching_rulePr x (a @ b # xs @ [xa]) = matching_rulePr x (a @ b # xs)"
by (simp add: matching_rulePr_def)*)

lemma CCponcEnd[rule_format]: "Cp a x = Some y \<longrightarrow>
                              Cp (list2policy (a#xs)) x = Some y"
 (is "?P xs")
apply (rule_tac P = ?P in list2policy.induct)
by (simp_all add:Cp.simps)

lemma CConcStartaux: " \<lbrakk>Cp a x = None\<rbrakk> \<Longrightarrow> (Cp aa ++ Cp a) x = Cp aa x"
by (simp add: PLemmas)

lemma CConcStart[rule_format]: "xs \<noteq> [] \<longrightarrow> Cp a x = None \<longrightarrow>
                             Cp (list2policy (a#xs)) x = Cp (list2policy xs) x"
apply (rule list2policy.induct)
by (simp_all add: PLemmas)

lemma mrNnt[simp]: "matching_rulePr x p = Some a \<Longrightarrow> p \<noteq> []"
apply (induct p,simp_all)
done


lemma mr_is_C[rule_format]: "matching_rulePr x p = Some a \<longrightarrow>
                             Cp (list2policy (p)) x = Cp a x"
apply (induct p)
apply simp_all
apply safe
apply (metis CCponcEnd)
apply (metis CCponcEnd rotate_simps)
by (metis CConcStart matching_rulePr.simps(2) not_None_eq option.simps(3))


lemma CConcStart2: "\<lbrakk>p \<noteq> []; x \<notin> dom (Cp a)\<rbrakk> \<Longrightarrow>
                    Cp (list2policy (a#p)) x = Cp (list2policy p)x"
by (erule CConcStart,simp add: PLemmas)

lemma CCponcEnd1: "\<lbrakk>q@p \<noteq> []; x \<notin> dom (Cp a)\<rbrakk> \<Longrightarrow>
                  Cp (list2policy (a#q@p)) x = Cp (list2policy (q@p))x"
apply simp
by (rule CConcStart2, simp_all)

lemma CCponcEnd2[rule_format]: "x \<in> dom (Cp a) \<longrightarrow>
                               Cp (list2policy (a#xs)) x = Cp a x"
by (metis matching_rulePr.simps(1) mr_is_C)

lemma bar3: "x \<in> dom (Cp (list2policy (a#xs))) \<longrightarrow>
             x \<in> dom (Cp (list2policy xs)) \<or> x \<in> dom (Cp a)"
apply (induct_tac xs)
apply simp_all
apply (rule impI)
apply (simp add: PLemmas)
apply auto
done


lemma CeqEnd[rule_format,simp]: "a \<noteq> [] \<longrightarrow> x \<in> dom (Cp (list2policy a)) \<longrightarrow> 
                                Cp (list2policy (a@b)) x = (Cp (list2policy a)) x"
apply (rule list2policy.induct)
apply (simp_all)
apply (rule impI)
apply (metis CCponcEnd2)
apply (rule impI)+
apply (case_tac "x \<in> dom (Cp xa)")
apply (metis Cdom2)
by (metis CConcStart2 append_Cons bar3 list.simps(2) list2policy.simps(2))

lemma CConcStartA[rule_format,simp]: " x \<in> dom (Cp a) \<longrightarrow>
                                      x \<in> dom (Cp (list2policy (a # b)))"
(is "?P b")
apply (rule_tac P = ?P in list2policy.induct)  
apply (simp_all add: Cp.simps)
done


lemma CeqStart[rule_format,simp]:
                          "x \<notin> dom (Cp (list2policy a)) \<longrightarrow> a \<noteq> [] \<longrightarrow> b \<noteq> [] \<longrightarrow>
                           Cp (list2policy (b@a)) x = (Cp (list2policy b)) x"
apply (rule list2policy.induct,simp_all)
apply (auto simp: list2policyconc PLemmas)
apply (simp_all split: option.splits)
done 

lemma C_eq_if_mr_eq2: "\<lbrakk>matching_rulePr x a = Some r; matching_rulePr x b = Some r;
                       a \<noteq> []; b \<noteq> []\<rbrakk>  \<Longrightarrow>
                       (Cp (list2policy a)) x = (Cp (list2policy b)) x"
by (metis mr_is_C)

lemma nMRtoNone[rule_format]: "p \<noteq> [] \<longrightarrow> matching_rulePr x p = None \<longrightarrow>
                               Cp (list2policy p) x = None"
apply (induct p, simp_all)
apply (simp_all add: dom_def)
apply (rule impI)+
apply simp
apply (case_tac "p=[]")
apply simp_all
by (metis CConcStart)


lemma C_eq_if_mr_eq: 
 "\<lbrakk>matching_rulePr x b = matching_rulePr x a; a \<noteq> []; b \<noteq> []\<rbrakk> \<Longrightarrow>  
  (Cp (list2policy a)) x = (Cp (list2policy b)) x"
apply (cases "matching_rulePr x a = None") 
apply simp_all
apply (subst nMRtoNone)
apply (simp_all)
apply (subst nMRtoNone)
apply simp_all
by (auto intro: C_eq_if_mr_eq2)



lemma notmatching_notdom: "matching_rulePr x (a#p) \<noteq> Some a \<Longrightarrow> x \<notin> dom (Cp a)"
apply (simp split: if_splits)
done


lemma foo3a[rule_format]: "matching_rulePr x (a@[b]@c) = Some b \<longrightarrow> r \<in> set a \<longrightarrow> 
                           b \<notin> set a \<longrightarrow> x \<notin> dom (Cp r)"
apply (induct a)
apply simp_all
done


lemma foo3D[rule_format]: "wellformed_policy1 p \<longrightarrow> r \<noteq> DenyAll \<longrightarrow> 
              matching_rulePr x p = Some DenyAll \<longrightarrow> r \<in> set p \<longrightarrow> x \<notin> dom (Cp r)"
apply (induct p)
apply simp_all
apply (rule conjI)
apply (rule impI)+
apply simp
apply (rule impI)+
apply simp
apply (drule mp)
apply (case_tac a,simp_all)
done


lemma foo4[rule_format]: "set p = set s \<and> (\<forall> r. r \<in> set p \<longrightarrow> x \<notin> dom (Cp r)) \<longrightarrow> 
                          (\<forall> r .r \<in> set s \<longrightarrow> x \<notin> dom (Cp r))"
by simp



lemma foo5b[rule_format]: "x \<in> dom (Cp b) \<longrightarrow>
                           matching_rulePr x (b#c) = Some b"
apply simp
done

lemma mr_first: "\<lbrakk>x \<in> dom (Cp b); (\<forall> r. r \<in> set c \<longrightarrow> x \<notin> dom (Cp r)); s = b#c\<rbrakk> \<Longrightarrow> 
                           matching_rulePr x s = Some b"
by (simp add: foo5b)

lemma mr_charn[rule_format]: "a \<in> set p \<longrightarrow> (x \<in> dom (Cp a)) \<longrightarrow> 
                             (\<forall> r. r \<in> set p \<and> x \<in> dom (Cp r) \<longrightarrow> r = a) \<longrightarrow>  
                              matching_rulePr x p = Some a"
apply (induct p)
apply simp_all
done 

lemma foo8: "\<lbrakk>(\<forall> r. r \<in> set p \<and> x \<in> dom (Cp r) \<longrightarrow> r = a); set p = set s\<rbrakk> \<Longrightarrow> 
             (\<forall> r. r \<in> set s \<and> x \<in> dom (Cp r) \<longrightarrow> r = a)"
by auto

(*
lemma mrConcEnd[rule_format]: "matching_rulePr x (b # p) = Some a \<longrightarrow> a \<noteq> b \<longrightarrow> 
                               matching_rulePr x p = Some a"
apply (simp add: matching_rulePr_def)
apply (rule_tac xs = p in rev_induct,simp_all) 
by auto
*)

lemma wp3tl[rule_format]: "wellformed_policy3Pr p \<longrightarrow> wellformed_policy3Pr (tl p)"
by (induct p, simp_all, case_tac a, simp_all)

lemma wp3Conc[rule_format]: "wellformed_policy3Pr (a#p) \<longrightarrow> wellformed_policy3Pr p"
by (induct p, simp_all, case_tac a, simp_all)

(*
lemma foo98[rule_format]:"matching_rulePr x (aa # p) = Some a \<longrightarrow> x \<in> dom (Cp r) \<longrightarrow> 
            r \<in> set p
           \<longrightarrow> a \<in> set p"
apply (simp add: matching_rulePr_def)
apply (rule rev_induct)
apply simp_all
apply (case_tac "r = xa", simp_all)
done
*)

lemma mrMTNone[simp]: "matching_rulePr x [] = None"
apply simp
done


lemma DAAux[simp]: "x \<in> dom (Cp DenyAll)"
by (simp add: dom_def PolicyCombinators.PolicyCombinators Cp.simps)

lemma mrSet[rule_format]: "matching_rulePr x p = Some r \<longrightarrow> r \<in> set p"
apply (induct p)
apply simp_all
done

lemma mr_not_Conc: "singleCombinators p \<Longrightarrow> matching_rulePr x p \<noteq> Some (a\<oplus>b)"
apply (auto simp:  mrSet)
apply (drule mrSet)
apply (erule SCnotConc,simp)
done


lemma foo25[rule_format]: "wellformed_policy3Pr (p@[x]) \<longrightarrow> wellformed_policy3Pr p"
by (induct p, simp_all, case_tac a, simp_all)

lemma mr_in_dom[rule_format]: "matching_rulePr x p = Some a \<longrightarrow> x \<in> dom (Cp a)"
apply (induct p,simp_all)
apply metis
done


(*lemma wp3EndMT[rule_format]: "wellformed_policy3Pr (xs#p) \<longrightarrow> 
                             AllowPortFromTo a b po \<in> set p \<longrightarrow>
                             dom (Cp (AllowPortFromTo a b po)) \<inter> dom (Cp xs) = {}"
apply (induct p,simp_all)
apply (case_tac xs,simp_all)
apply (rule impI)
apply (rule conjI)
apply (rule impI)+
apply simp
apply simp_all
apply (induct p,simp_all)
apply (rule impI)+
apply (rule conjI)
apply (case_tac aa,simp_all)
apply simp_all
apply (drule mp)
apply (erule wp3Conc)
apply (rule conjI)
apply simp_all
apply (rule impI)
apply simp
apply auto
by clarify auto*)

lemma foo29: "\<lbrakk>dom (Cp a) \<noteq> {}; dom (Cp a) \<inter> dom (Cp b) = {}\<rbrakk> \<Longrightarrow> a \<noteq> b"
by auto

lemma foo28:  "\<lbrakk>AllowPortFromTo a b po \<in> set xs; 
               dom (Cp (AllowPortFromTo a b po)) \<noteq> {}; (wellformed_policy3Pr (x#xs))\<rbrakk> 
               \<Longrightarrow> x \<noteq> AllowPortFromTo a b po"
oops


lemma foo28a[rule_format]: "x \<in> dom (Cp a) \<Longrightarrow> dom (Cp a) \<noteq> {}"
by auto

lemma allow_deny_dom[simp]: "dom (Cp (AllowPortFromTo a b po)) \<subseteq> 
                            dom (Cp (DenyAllFromTo a b))"
by (simp_all add: twoNetsDistinct_def netsDistinct_def PLemmas) auto 

lemma DenyAllowDisj: "dom (Cp (AllowPortFromTo a b p)) \<noteq> {} \<Longrightarrow> 
             dom (Cp (DenyAllFromTo a b)) \<inter> dom (Cp (AllowPortFromTo a b p))  \<noteq> {}"
by (metis Int_absorb1 allow_deny_dom)

lemma foo31: "\<lbrakk>(\<forall> r. r \<in> set p \<and> x \<in> dom (Cp r) \<longrightarrow> 
           (r = AllowPortFromTo a b po \<or> r = DenyAllFromTo a b \<or> r = DenyAll)); 
            set p = set s\<rbrakk> \<Longrightarrow> 
            (\<forall> r. r \<in> set s \<and> x \<in> dom (Cp r) \<longrightarrow> 
           (r = AllowPortFromTo a b po \<or> r = DenyAllFromTo a b \<or> r = DenyAll))"
by auto



lemma wp1_auxa: "wellformed_policy1_strong p\<Longrightarrow>(\<exists> r. matching_rulePr x p = Some r)"
apply (rule DAimpliesMR_E)
by (erule wp1_aux1aa)



lemma deny_dom[simp]:  "twoNetsDistinct a b c d \<Longrightarrow> dom (Cp (DenyAllFromTo a b)) \<inter>
                       dom (Cp (DenyAllFromTo c d)) = {}"
apply (simp add: Cp.simps)
by (erule aux6)

lemma domTrans: "\<lbrakk>dom a \<subseteq> dom b; dom(b) \<inter> dom (c) = {}\<rbrakk> \<Longrightarrow> dom(a) \<inter> dom(c) = {}" 
by auto

lemma DomInterAllowsMT: "\<lbrakk> twoNetsDistinct a b c d\<rbrakk>  \<Longrightarrow>
        dom (Cp (AllowPortFromTo a b p)) \<inter> dom (Cp (AllowPortFromTo c d po)) = {}"
apply (case_tac "p = po", simp_all)
apply (rule_tac b = "Cp (DenyAllFromTo a b)" in domTrans, simp_all)
apply (metis PLemmas(6) PLemmas(7) aux26a mt_sym tNDComm)
by (smt IntI PLemmas(7) allow_deny_dom bex_empty deny_dom disjoint_iff_not_equal mem_def set_rev_mp)

lemma DomInterAllowsMT_Ports: "\<lbrakk>p \<noteq> po\<rbrakk> \<Longrightarrow>
        dom (Cp (AllowPortFromTo a b p)) \<inter> dom (Cp (AllowPortFromTo c d po)) = {}"
apply (simp add: twoNetsDistinct_def netsDistinct_def PLemmas) 
apply auto
by (metis surjective_pairing)




lemma wellformed_policy3Pr_charn[rule_format]: 
  "singleCombinators p \<longrightarrow> distinct p \<longrightarrow> allNetsDistinct p \<longrightarrow> 
   wellformed_policy1 p \<longrightarrow> wellformed_policy2Pr p  \<longrightarrow> wellformed_policy3Pr p"
apply (induct_tac p)   
apply simp_all
apply clarify
apply simp_all
apply (auto intro: singleCombinatorsConc ANDConc waux2 wp2Conc)
apply (case_tac a) 
apply simp_all
apply (case_tac a)
apply simp_all
apply (metis DomInterAllowsMT DomInterAllowsMT_Ports Int_commute PLemmas(7) aux5c aux5d aux7aa bex_triv_one_point2 fst_conv mt_sym snd_conv surjective_pairing) 
done



lemma DistinctNetsDenyAllow: 
 "\<lbrakk>DenyAllFromTo b c \<in> set p; AllowPortFromTo a d po \<in> set p; allNetsDistinct p;
  dom (Cp (DenyAllFromTo b c)) \<inter> dom (Cp (AllowPortFromTo a d po)) \<noteq> {}\<rbrakk>
       \<Longrightarrow> b = a \<and> c = d" 
apply (simp add: allNetsDistinct_def)
apply (frule_tac x = "b" in spec) 
apply (drule_tac x = "d" in spec)
apply (drule_tac x = "a" in spec)
apply (drule_tac x = "c" in spec)
by (metis ND0aux1 ND0aux2 ND0aux3 ND0aux4 PLemmas(6) PLemmas(7) aux26a ba bex_triv_one_point2 mt_sym twoNetsDistinct_def)

lemma DistinctNetsAllowAllow: 
 "\<lbrakk>AllowPortFromTo b c poo \<in> set p; AllowPortFromTo a d po \<in> set p; 
  allNetsDistinct p; dom (Cp (AllowPortFromTo b c poo)) \<inter> 
  dom (Cp (AllowPortFromTo a d po)) \<noteq> {}\<rbrakk>
       \<Longrightarrow> b = a \<and> c = d \<and> poo = po" 
apply (simp add: allNetsDistinct_def)
apply (frule_tac x = "b" in spec) 
apply (drule_tac x = "d" in spec)
apply (drule_tac x = "a" in spec)
apply (drule_tac x = "c" in spec)
by (metis DomInterAllowsMT DomInterAllowsMT_Ports ND0aux3 ND0aux4 PLemmas(7) ba twoNetsDistinct_def)



lemma WP2RS2[simp]: 
  "\<lbrakk>singleCombinators p;
 distinct p;
 allNetsDistinct p\<rbrakk> \<Longrightarrow> 
   wellformed_policy2Pr (removeShadowRules2 p)"
 proof (induct p)
   case Nil thus ?case by simp
 next   
   case (Cons x xs) 
      have wp_xs: "wellformed_policy2Pr (removeShadowRules2 xs)" using prems
by (metis ANDConc distinct.simps(2) singleCombinatorsConc)
      show ?case
      proof (cases x) 
         case DenyAll thus ?thesis using wp_xs by simp
      next  
         case (DenyAllFromTo a b) thus ?thesis
           using wp_xs  prems
apply simp
sorry      next
         case (AllowPortFromTo a b p) thus ?thesis
             using assms wp_xs 
        apply simp done
next
         case (Conc a b) thus ?thesis
             using assms by (metis Conc Cons(2) singleCombinators.simps(2)) 
      qed
 qed



lemma AD_aux: "\<lbrakk>AllowPortFromTo a b po \<in> set p ;DenyAllFromTo c d \<in> set p; 
                allNetsDistinct  p ; singleCombinators p; 
        a \<noteq> c \<or> b \<noteq> d\<rbrakk>
    \<Longrightarrow> dom (Cp (AllowPortFromTo a b po)) \<inter> dom (Cp (DenyAllFromTo c d)) = {}"
apply (rule aux26a)
apply (rule_tac x ="AllowPortFromTo a b po" and y = "DenyAllFromTo c d" in tND)
apply auto 
done


lemma aux7a1: "\<lbrakk>AllowPortFromTo c d po \<in> set p;
              allNetsDistinct ((DenyAllFromTo a b)#p); a \<noteq> c\<or> b \<noteq> d\<rbrakk> \<Longrightarrow> 
              twoNetsDistinct a b c d"
apply (erule_tac x = "DenyAllFromTo a b" and
                 y = "AllowPortFromTo  c d po" in tND)
apply simp_all
done

lemma domDAsorted: "\<lbrakk>allNetsDistinct xs; (DenyAllFromTo c d) \<in> set xs; (AllowPortFromTo a b p) \<in> set xs;
      twoNetsDistinct a b c d; smaller (DenyAllFromTo c d) (AllowPortFromTo a b p) l\<rbrakk>
       \<Longrightarrow> dom (Cp (DenyAllFromTo c d)) \<inter> dom (Cp (AllowPortFromTo a b p)) = {}"
apply (simp split: if_splits)
by (metis Int_commute PLemmas(6) aux26a)

lemma domDAsorted1: "\<lbrakk>smaller (DenyAllFromTo c d) (AllowPortFromTo a b p) l\<rbrakk>
       \<Longrightarrow> {c,d} \<noteq> {a,b}"
apply (simp split: if_splits)
done

lemma  smaller_rm[rule_format]:
 "smaller a b l \<longrightarrow> sorted (b # xs) l \<longrightarrow> all_in_list xs l \<longrightarrow> singleCombinators[a]
 \<longrightarrow> singleCombinators [b] \<longrightarrow> singleCombinators xs \<longrightarrow> 
  in_list a l \<longrightarrow> in_list b l \<longrightarrow> LRFWCompilation.sorted (a # xs) l"
apply (induct xs)
apply simp_all
apply (rule impI)+
apply simp
apply (rule order_trans)
apply simp_all
apply auto
done



lemma sorted_is_smaller[rule_format]: "singleCombinators xs \<longrightarrow> singleCombinators[x] \<longrightarrow>
 singleCombinators [a] \<longrightarrow>  sorted (x#xs) l \<longrightarrow> a \<in> set xs \<longrightarrow> 
  all_in_list xs l \<longrightarrow> in_list x l \<longrightarrow> in_list a l \<longrightarrow> smaller x a l"
apply (induct xs)
apply simp_all
apply (rule impI)+
apply (case_tac x,simp_all)
apply (drule mp)
apply simp_all
apply (case_tac aa,simp_all)
apply (drule mp)
apply (case_tac aa,simp_all)
apply (drule mp)
apply (rule_tac b = aa in smaller_rm)
apply simp_all
apply (case_tac aa,simp_all)
apply (metis SCp2l bothNet.simps(3) destNet.simps(2) in_list.simps(3) policy2list.simps(4) singleCombinatorsConc singleCombinatorsStart smaller_rm srcNet.simps(2))
done

lemma sorted_WP2[rule_format]: "sorted p l \<longrightarrow> all_in_list p l \<longrightarrow> distinct p \<longrightarrow> singleCombinators p \<longrightarrow> 
            allNetsDistinct p \<longrightarrow> singleCombinators p \<longrightarrow> wellformed_policy2Pr p"
proof (induct p)
 case Nil thus ?case by simp 
next
 case (Cons a p) thus ?case
  proof (cases a)
   case DenyAll thus ?thesis using assms Cons
               by (auto intro: ANDConc singleCombinatorsConc sortedConcEnd)
  next
   case (DenyAllFromTo c d) thus ?thesis using assms Cons
     apply simp
     apply (rule impI)+
     apply (rule conjI)
     apply (rule allI)+
     apply (rule impI)+
     apply simp_all
     apply (simp_all add: ANDConc sortedConc)
     apply (case_tac ca,simp_all)
     apply (rule deny_dom)
     apply (metis aux7 tNDComm) defer 1
     apply (metis SCnotConc)
     apply (subgoal_tac "smaller (DenyAllFromTo c d) (AllowPortFromTo \<alpha>1 \<alpha>2 \<beta>) l")
     apply (metis aux26a aux7a1 domDAsorted1 mt_sym tNDComm)
     apply (erule sorted_is_smaller)
     apply simp_all
     by (metis bothNet.simps(3) in_list.simps(3) in_set_in_list)
   next
   case (AllowPortFromTo c d e) thus ?thesis using Cons assms
      apply (simp)
      apply (rule impI|rule conjI|rule allI)+
      by (metis ANDConc AllowPortFromTo Cons sortedConc) 
   next
   case (Conc a b) thus ?thesis using Cons by simp 
   qed
qed



lemma wellformed2_sorted[simp]: "\<lbrakk>all_in_list p l; distinct p; allNetsDistinct p;
                         singleCombinators p\<rbrakk> \<Longrightarrow> wellformed_policy2Pr (sort p l)"
apply (rule sorted_WP2)
apply (erule sort_is_sorted, simp_all)
apply (erule all_in_listSubset)
by (auto intro: SC3 singleCombinatorsConc sorted_insort)


lemma C_DenyAll[simp]: "Cp (list2policy (DenyAll#xs)) x = Some (deny ())"
by (metis CCponcEnd PLemmas(5) deny_all_def)

(*
lemma C_eq_RS1n:
   "Cp(list2policy (removeShadowRules1_alternative p)) = Cp(list2policy p)"
apply (case_tac "p = []")
apply simp_all

apply (metis rSR1_eq removeShadowRules1.simps(2))
apply (rule rev_induct)
apply (metis rSR1_eq removeShadowRules1.simps(2))
apply (case_tac "xs = []", simp_all)
apply (simp add: removeShadowRules1_alternative_def)
apply (case_tac x, simp_all)
apply (rule ext) 
apply (case_tac "x = DenyAll")
apply (simp_all add: C_DenyAll PLemmas)
apply (rule_tac t = "removeShadowRules1_alternative (xs @ [x])" and
               s = "(removeShadowRules1_alternative xs)@[x]" in subst)
apply (erule RS1n_assoc)
apply (case_tac "xa \<in> dom (Cp x)")
apply simp_all
done
*)


lemma rsNMT[rule_format]: "p \<noteq> [] \<longrightarrow> removeShadowRules1 p \<noteq> []"
apply (induct p)
apply simp_all
done

lemma C_eq_RS1[rule_format,simp]: "p \<noteq> [] \<longrightarrow>
                       Cp(list2policy (removeShadowRules1 p)) = Cp(list2policy p)"
apply (induct_tac p,simp_all)
apply (rule conjI)
apply (rule impI|simp_all)+
apply (metis CCponcEnd2 C_DenyAll DAAux ext)
apply (rule impI|simp_all)+
apply (case_tac "list=[]")
apply simp_all
apply (rule ext)
apply (case_tac "x \<in> dom (Cp a)")
apply (metis CCponcEnd2)
apply (subgoal_tac " Cp (list2policy (a # removeShadowRules1 list)) x =  Cp (list2policy (removeShadowRules1 list)) x")
apply (subgoal_tac " Cp (list2policy (a # list)) x =  Cp (list2policy list) x")
apply simp
apply (metis CConcStart2)
apply (rule CConcStart2)
apply (erule rsNMT)
apply simp_all
done


lemma EX_MR_aux[rule_format]: "matching_rulePr x (DenyAll # p) \<noteq> Some DenyAll \<longrightarrow>
                               (\<exists>y. matching_rulePr x p = Some y)"
apply (induct_tac p,simp_all)
done

lemma EX_MR : "\<lbrakk>matching_rulePr x p \<noteq> (Some DenyAll); p = DenyAll#ps\<rbrakk> \<Longrightarrow> 
                           (matching_rulePr x p = matching_rulePr x ps)"
apply auto
done

lemma mr_not_DA:
  "\<lbrakk>wellformed_policy1_strong s; matching_rulePr x p = Some (DenyAllFromTo a ab);
    set p = set s\<rbrakk> \<Longrightarrow> matching_rulePr x s \<noteq> Some DenyAll"
apply (subst wp1n_tl, simp_all)
apply (subgoal_tac "x \<in> dom (Cp (DenyAllFromTo a ab))")
apply (subgoal_tac "DenyAllFromTo a ab \<in> set ( s)")
apply (metis foo3D mrNnt mrSet wellformed_policy1.simps(2) wellformed_policy1.simps(3) wp1_eq wp1n_tl)
apply (metis mrSet)
by (metis mr_in_dom)


lemma domsMT_notND_DD: 
   "\<lbrakk>dom (Cp (DenyAllFromTo a b)) \<inter> dom (Cp (DenyAllFromTo c d)) \<noteq> {}\<rbrakk> \<Longrightarrow>
     \<not> netsDistinct a c"
apply (erule contrapos_nn)
apply (simp add: Cp.simps)
apply (rule aux6)
apply (simp add: twoNetsDistinct_def)
done


lemma domsMT_notND_DD2: 
  "\<lbrakk>dom (Cp (DenyAllFromTo a b)) \<inter> dom (Cp (DenyAllFromTo c d)) \<noteq> {}\<rbrakk> \<Longrightarrow>
   \<not> netsDistinct b d"
apply (erule contrapos_nn)
apply (simp add: Cp.simps)
apply (rule aux6)
apply (simp add: twoNetsDistinct_def)
done

lemma domsMT_notND_DD3: 
  "\<lbrakk>x \<in> dom (Cp (DenyAllFromTo a b)); x \<in> dom (Cp (DenyAllFromTo c d))\<rbrakk> \<Longrightarrow>
   \<not> netsDistinct a c"
apply (rule domsMT_notND_DD)
apply auto
done

lemma domsMT_notND_DD4: 
  "\<lbrakk>x \<in> dom (Cp (DenyAllFromTo a b)); x \<in> dom (Cp (DenyAllFromTo c d))\<rbrakk> \<Longrightarrow>
   \<not> netsDistinct b d"
apply (rule domsMT_notND_DD2)
apply auto
done

lemma NetsEq_if_sameP_DD: 
  "\<lbrakk>allNetsDistinct p; u\<in> set p; v\<in> set p; u = (DenyAllFromTo a b); 
   v = (DenyAllFromTo c d); x \<in> dom (Cp (u)); x \<in> dom (Cp (v))\<rbrakk> \<Longrightarrow> 
    a = c \<and> b = d"
apply (simp add: allNetsDistinct_def)
apply (metis ND0aux1 ND0aux2 domsMT_notND_DD3 domsMT_notND_DD4 mem_def)
done


lemma rule_charn1: 
 assumes aND: "allNetsDistinct p"
 and mr_is_allow: "matching_rulePr x p = Some (AllowPortFromTo a b po)"
 and SC: "singleCombinators p"
 and inp: "r \<in> set p" 
 and inDom: "x \<in> dom (Cp r)"
 shows "(r = AllowPortFromTo a b po \<or> r = DenyAllFromTo a b \<or> r = DenyAll)"
proof (cases r) 
  case DenyAll show ?thesis  by (metis DenyAll)
next
  case (DenyAllFromTo x y) show ?thesis using Cons assms prems
     apply (simp,rule_tac  p = p and po =po in DistinctNetsDenyAllow, simp_all)
     apply (metis mrSet)
     by (metis Int_iff mr_in_dom inSet_not_MT set_empty2)
next
  case (AllowPortFromTo x y b) show ?thesis using prems Cons
     apply simp
     apply (rule DistinctNetsAllowAllow, simp_all)
     apply (metis mrSet)
     by (metis Int_iff mr_in_dom inSet_not_MT set_empty2)
next
  case (Conc x y) thus ?thesis using Cons prems by (metis aux0_0)
qed


lemma nMTRS3[simp]: "noneMTPr (removeShadowRules3Pr p)"
by (induct p) simp_all

lemma nMTcharn: "noneMTPr p = (\<forall> r \<in> set p. dom (Cp r) \<noteq> {})"
by (induct p) simp_all

lemma nMTeqSet: "set p = set s \<Longrightarrow> noneMTPr p = noneMTPr s"
by (simp add: nMTcharn)

lemma nMTSort: "noneMTPr p \<Longrightarrow> noneMTPr (sort p l)"
by (metis set_sort nMTeqSet)

lemma wp3char[rule_format]: "noneMTPr xs \<and>  Cp (AllowPortFromTo a b po) = empty \<and> 
                            wellformed_policy3Pr ((DenyAllFromTo a b)#xs) \<longrightarrow> 
                             AllowPortFromTo a b po \<notin> set xs"
apply (induct xs)
apply simp_all
by (metis domNMT wp3Conc)

lemma " dom (Cp (AllowPortFromTo a b po)) \<noteq> {}"
apply (simp add: PLemmas)
apply auto
oops

lemma wp3charn[rule_format]: 
 "dom (Cp (AllowPortFromTo a b po)) \<noteq> {} \<longrightarrow> wellformed_policy3Pr ((DenyAllFromTo a b)#xs) \<longrightarrow>
 AllowPortFromTo a b po \<notin> set xs"
apply (induct xs)
apply simp_all
apply (rule impI)+
apply simp
apply (rule conjI)
defer 1
apply (drule mp)
apply (rule_tac a = aa in  wp3Conc)
apply simp_all
apply (drule mp)
apply (rule_tac a = aa in  wp3Conc)
apply simp_all
apply (frule conjunct1)
apply (drule_tac x = a in spec)
apply (drule_tac x = b in spec)
apply (drule_tac x = "(fst po)" in spec)
apply (drule_tac x = "(snd po)" in spec)
apply simp
apply (subgoal_tac " dom (Cp (DenyAllFromTo a b)) \<inter> dom (Cp (AllowPortFromTo a b po)) \<noteq> {}")
apply metis
by (metis DenyAllowDisj)

lemma notMTnMT: "\<lbrakk>a \<in> set p; noneMTPr p\<rbrakk> \<Longrightarrow> dom (Cp a) \<noteq> {}"
by (simp add: nMTcharn)

lemma noneMTPrconc[rule_format]: "noneMTPr (a@[b]) \<longrightarrow> noneMTPr a"
by (induct a, simp_all)

lemma rule_charn2: 
 assumes aND: "allNetsDistinct p"
 and wp1: "wellformed_policy1 p"
 and SC: "singleCombinators p"
 and wp3: "wellformed_policy3Pr p"
 and allow_in_list: "AllowPortFromTo c d po \<in> set p"
 and x_in_dom_allow: "x \<in> dom (Cp (AllowPortFromTo c d po))"
 shows  "matching_rulePr x p = Some (AllowPortFromTo c d po)"
 proof  (insert prems, induct p)    
   case Nil show ?case using prems by simp
 next 
   case (Cons y ys) show ?case using prems
     apply simp
     apply (case_tac "y = (AllowPortFromTo c d po)")
     apply simp_all
     apply (subgoal_tac "ys \<noteq> []")
     apply (rule conjI)
     apply (case_tac y,simp_all)
apply (metis Cons(5) Cons(7) Int_commute allow_in_list aux5c aux5d bex_triv_one_point2 domInterMT wellformed_policy3Pr.simps(3))
apply (metis Cons(5) Cons(7) allow_in_list aux5c aux5d bex_triv_one_point2 domComm domInterMT wellformed_policy3Pr.simps(4))
     apply (rule impI)
     apply (case_tac y,simp_all)
apply (metis ANDConc Cons(2))
apply (metis ANDConc Cons(2))
by (metis List.set.simps(1) empty_iff)
qed


lemma rule_charn3: 
 "\<lbrakk>wellformed_policy1 p; allNetsDistinct p; singleCombinators p; 
  wellformed_policy3Pr p; matching_rulePr x p = Some (DenyAllFromTo c d); 
  AllowPortFromTo a b po \<in> set p\<rbrakk> \<Longrightarrow> x \<notin> dom (Cp (AllowPortFromTo a b po))"
by (clarify, auto simp: rule_charn2 dom_def) 

lemma rule_charn4: 
assumes wp1: "wellformed_policy1 p" 
and aND: "allNetsDistinct p" 
and SC: "singleCombinators p"
and wp3: "wellformed_policy3Pr p"  
and DA: "DenyAll \<notin> set p" 
and mr: "matching_rulePr x p = Some (DenyAllFromTo a b)"
and rinp: "r \<in> set p"
and xindom: "x \<in> dom (Cp r)"
shows "r = DenyAllFromTo a b"
proof (cases r)
  case DenyAll thus ?thesis using prems by simp 
next
  case (DenyAllFromTo c d) thus ?thesis using prems apply simp
    apply (erule_tac x = x and p = p and v = "(DenyAllFromTo a b)" and
                     u = "(DenyAllFromTo c d)"  in NetsEq_if_sameP_DD)
    apply simp_all
    apply (erule mrSet)
    by (erule mr_in_dom) 
next
  case (AllowPortFromTo c d e) thus ?thesis using prems apply simp
    apply (subgoal_tac "x \<notin> dom (Cp  (AllowPortFromTo c d e))")
    apply simp 
    apply (rule_tac p = p in rule_charn3)
    by (auto intro: SCnotConc) 
next
  case (Conc a b) thus ?thesis using prems apply simp
      by (metis Conc aux0_0 in_set_conv_decomp) 
qed


lemma nMTtail[rule_format]: "noneMTPr p \<longrightarrow> noneMTPr (tl p)"
by (induct p, simp_all)


lemma foo31a: "\<lbrakk>(\<forall> r. r \<in> set p \<and> x \<in> dom (Cp r) \<longrightarrow>
           (r = AllowPortFromTo a b po \<or> r = DenyAllFromTo a b \<or> r = DenyAll));
           set p = set s; r \<in> set s ; x \<in> dom (Cp r)\<rbrakk> \<Longrightarrow>
           (r = AllowPortFromTo a b po \<or> r = DenyAllFromTo a b \<or> r = DenyAll)"
by auto


lemma aux4[rule_format]: 
  "matching_rulePr x (p@[a]) = Some a \<longrightarrow> a \<notin> set (p) \<longrightarrow> matching_rulePr x p = None"
apply (induct p)
apply simp_all
done

lemma mrDA_tl: 
 assumes mr_DA: "matching_rulePr x p = Some DenyAll"
 and wp1n: "wellformed_policy1_strong p"
 shows "matching_rulePr x (butlast p) = None"
 apply (rule aux4 [where a = DenyAll])
 apply (metis wp1n_tl mr_DA wp1n)
by (metis wp1_charn2 wp1n)


lemma mr_butlast[rule_format]:
  "matching_rulePr x p = Some r \<longrightarrow> r \<in> set (butlast p) \<longrightarrow>
   p = butlast p @ [DenyAll]
   \<longrightarrow> matching_rulePr x (butlast p) = Some r"
apply (induct p)
apply simp_all
apply (rule conjI)
apply (rule impI)+
apply (simp_all)
apply (rule impI|rule conjI)+
apply simp
apply (rule impI|rule conjI)+
by (simp add: mr_in_dom)


lemma mr_butlasta[rule_format]:
  "matching_rulePr x p = Some r \<longrightarrow> r \<noteq> DenyAll \<longrightarrow>
   p = butlast p @ [DenyAll]
   \<longrightarrow> matching_rulePr x (butlast p) = Some r"
apply (induct p)
apply simp_all
apply (rule impI)+
apply (simp_all)
done


lemma rule_charnDAFT: 
"\<lbrakk>wellformed_policy1_strong p; allNetsDistinct p; singleCombinators p; 
  wellformed_policy3Pr p; matching_rulePr x p = Some (DenyAllFromTo a b);
  r \<in> set (butlast p); x \<in> dom (Cp r)\<rbrakk> \<Longrightarrow> r = DenyAllFromTo a b"
apply (subgoal_tac "p = (butlast p)@[DenyAll]")
apply (rule_tac p = "butlast p" in rule_charn4)
apply simp_all
apply (metis WP1ConcEnd wp1_eq)
apply (metis ANDConcEnd SCConcEnd)
apply (metis SCConcEnd)
apply (metis foo25)
apply (metis bex_triv_one_point1 wp1_charn2)
apply (rule mr_butlast)
apply simp_all
apply (metis Combinators.simps(5) List.set.simps(1) List.set.simps(2) aux0_4 mem_def mrSet singletonE wp1n_tl)
by (metis wp1n_tl)

lemma mrDenyAll_is_unique: 
  "\<lbrakk>wellformed_policy1_strong p; matching_rulePr x p = Some DenyAll;
   r \<in> set (butlast p)\<rbrakk> \<Longrightarrow> x \<notin> dom (Cp r)"
apply (rule_tac c = "[]" and b = "DenyAll" and a = "butlast p"  in foo3a, simp_all)  
apply (metis wp1n_tl)
by (metis wp1_charn2)


lemma mr_last[rule_format]: 
  "s \<noteq> [] \<longrightarrow> y = last s \<longrightarrow> x \<in> dom (Cp y) \<longrightarrow> (\<forall> r. r \<in> set (butlast s) \<longrightarrow> x \<notin> dom (Cp r)) \<longrightarrow> 
                           matching_rulePr x s = Some y"
apply (induct s)
apply auto
done


lemma mr_butlast2[rule_format]: "matching_rulePr x (butlast s) = Some r \<longrightarrow> last s \<noteq> r \<longrightarrow> 
 matching_rulePr x s = Some r"
apply (induct s)
apply simp_all
done

theorem  C_eq_Sets_mr: 
 assumes sets_eq: "set p = set s"
 and SC: "singleCombinators p"
 and wp1_p: "wellformed_policy1_strong p"
 and wp1_s: "wellformed_policy1_strong s"
 and wp3_p: "wellformed_policy3Pr p"       
 and wp3_s: "wellformed_policy3Pr s"  
 and aND: "allNetsDistinct p"        
   
 shows "matching_rulePr x p = matching_rulePr x s"
proof (cases "matching_rulePr x p")

 case None 
     have DA: "DenyAll \<in> set p" using wp1_p by (auto simp: wp1_aux1aa)
     have notDA: "DenyAll \<notin> set p" using None by (auto simp: DAimplieMR) 
     thus ?thesis using DA by (contradiction)
 next
 
 case (Some y) thus ?thesis
   proof (cases y) 
      have tl_p: "p = (butlast p)@[DenyAll]" by (metis wp1_p wp1n_tl) 
      have tl_s: "s = (butlast s)@[DenyAll]" by (metis wp1_s wp1n_tl)
      have tl_eq: "set (butlast p) = set (butlast s)" using sets_eq tl_p tl_s
by (smt append_eq_append_conv2 foo2 list2policyR.simps(1) rotate_simps set_rotate1 snoc_eq_iff_butlast wp1_charn2 wp1_p wp1_s)
    {
   case DenyAll
     have mr_p_is_DenyAll: "matching_rulePr x p = Some DenyAll"
        by (simp add: DenyAll Some)
     hence x_notin_tl_p: "\<forall> r. r \<in> set (butlast p) \<longrightarrow>  x \<notin> dom (Cp r)" using wp1_p
        by (auto simp: mrDenyAll_is_unique)
     hence x_notin_tl_s: "\<forall> r. r \<in> set (butlast s) \<longrightarrow>  x \<notin> dom (Cp r)" using tl_eq
        by auto
     hence mr_s_is_DenyAll: "matching_rulePr x s = Some DenyAll" using tl_s  
        apply (rule_tac y = DenyAll and s = "s" in mr_last)
        apply simp_all
        apply auto
     by (metis DenyAll last_snoc tl_s)
             thus ?thesis using mr_p_is_DenyAll by simp
}
{   case (DenyAllFromTo a b) 
     have mr_p_is_DAFT: "matching_rulePr x p = Some (DenyAllFromTo a b)"
        by (simp add: DenyAllFromTo Some)
     have DA_notin_tl: "DenyAll \<notin> set (butlast p)"
by (metis wp1_charn2 wp1_p)
     have mr_tl_p: "matching_rulePr x p = matching_rulePr x (butlast p)" using  mr_p_is_DAFT tl_p
       apply simp 
       apply (rule sym)
       apply (rule mr_butlasta)
       by simp_all
        have dom_tl_p: "\<And> r. r \<in> set (butlast p) \<and> x \<in> dom (Cp r) \<Longrightarrow> 
                     r = (DenyAllFromTo a b)"

       using wp1_p aND SC wp3_p mr_p_is_DAFT
       by (auto simp: rule_charnDAFT)
     hence dom_tl_s: "\<And> r. r \<in> set (butlast s) \<and> x \<in> dom (Cp r) \<Longrightarrow> 
                      r = (DenyAllFromTo a b)"
       using tl_eq  by auto
     have DAFT_in_tl_s: "DenyAllFromTo a b \<in> set (butlast s)" using mr_tl_p
       by (metis DenyAllFromTo mrSet mr_p_is_DAFT tl_eq)
     have x_in_dom_DAFT: "x \<in> dom (Cp (DenyAllFromTo a b))"
       by (metis mr_p_is_DAFT DenyAllFromTo mr_in_dom)
     hence mr_tl_s_is_DAFT: "matching_rulePr x (butlast s) = Some (DenyAllFromTo a b)"
       using DAFT_in_tl_s dom_tl_s  by (auto simp: mr_charn)
     hence mr_s_is_DAFT: "matching_rulePr x s = Some (DenyAllFromTo a b)"
       using tl_s 
       apply (rule_tac r = "DenyAllFromTo a b" in mr_butlast2)
       apply simp_all
by (metis Combinators.simps(4) DenyAllFromTo last_snoc tl_s)
     thus ?thesis using mr_p_is_DAFT by simp
}
{  case (AllowPortFromTo a b c)
     have wp1s: "wellformed_policy1 s" by (metis wp1_eq wp1_s)
     have mr_p_is_A: "matching_rulePr x p = Some (AllowPortFromTo a b c)"
       by (simp add: AllowPortFromTo Some)
     hence A_in_s: "AllowPortFromTo a b c \<in> set s" using sets_eq
       by (auto intro: mrSet)
     have x_in_dom_A: "x \<in> dom (Cp (AllowPortFromTo a b c))"
       by (metis mr_p_is_A AllowPortFromTo mr_in_dom)
     have SCs: "singleCombinators s" using SC sets_eq
       by (auto intro: SCSubset)
     hence ANDs: "allNetsDistinct s" using aND sets_eq SC
       by (auto intro: aNDSetsEq)
     hence mr_s_is_A: "matching_rulePr x s = Some (AllowPortFromTo a b c)"
       using A_in_s wp1s mr_p_is_A aND SCs wp3_s x_in_dom_A
          by (simp add: rule_charn2)
     thus ?thesis using mr_p_is_A by simp
}
    case (Conc a b) thus ?thesis by (metis Some mr_not_Conc SC) 
 qed
qed

lemma C_eq_Sets: 
"\<lbrakk>singleCombinators p; wellformed_policy1_strong p; wellformed_policy1_strong s;
wellformed_policy3Pr p; wellformed_policy3Pr s; allNetsDistinct p; set p = set s\<rbrakk> \<Longrightarrow>
  Cp (list2policy p) x  = Cp (list2policy s) x"
  apply (rule C_eq_if_mr_eq)
  apply (rule C_eq_Sets_mr [symmetric])
  apply simp_all
done

lemma C_eq_sorted: "\<lbrakk>distinct p; all_in_list p l; singleCombinators p;
        wellformed_policy1_strong p; wellformed_policy3Pr p; allNetsDistinct p\<rbrakk> \<Longrightarrow>
        Cp (list2policy (sort p l))= Cp (list2policy p)"
 apply (rule ext)
 apply (rule C_eq_Sets)
 apply (auto simp: nMTSort wellformed1_alternative_sorted
                  wellformed_policy3Pr_charn wellformed1_sorted wp1_eq)
done



lemma mrconc[rule_format]: "matching_rulePr x p = Some a \<longrightarrow>
                            matching_rulePr x (p@[q]) = Some a"
apply (induct p)
apply simp_all
done

lemma mreq_end: "\<lbrakk>matching_rulePr x b = Some r; matching_rulePr x c = Some r\<rbrakk> \<Longrightarrow> 
 matching_rulePr x (a#b) = matching_rulePr x (a#c)"
by (simp add: mrconc)


lemma mreq_end2a: "\<lbrakk>matching_rulePr x b = Some r; matching_rulePr x c = Some r\<rbrakk> \<Longrightarrow> 
 matching_rulePr x (b@[a]) = matching_rulePr x (c@[a])"
by (simp add: mrconc)

lemma mrconcNone[rule_format]: "matching_rulePr x p = None \<longrightarrow>
                                matching_rulePr x (b#p) = matching_rulePr x [b]"
apply (rule_tac xs = p in rev_induct) 
apply simp_all
done

lemma mreq_endNone: "\<lbrakk>matching_rulePr x b = None; matching_rulePr x c = None\<rbrakk> \<Longrightarrow> 
     matching_rulePr x (a#b) = matching_rulePr x (a#c)"
by (metis mrconcNone)


lemma mrconcNone2[rule_format]: "matching_rulePr x p = None \<longrightarrow>
                                matching_rulePr x (p@[q]) = matching_rulePr x [q]"
apply (induct p)
apply simp_all
done

lemma mreq_endNone2: "\<lbrakk>matching_rulePr x b = None; matching_rulePr x c = None\<rbrakk> \<Longrightarrow> 
     matching_rulePr x (b@[a]) = matching_rulePr x (c@[a])"
by (metis mrconcNone2)


lemma mreq_end2: "matching_rulePr x b = matching_rulePr x c \<Longrightarrow> 
     matching_rulePr x (b@[a]) = matching_rulePr x (c@[a])"
apply (case_tac "matching_rulePr x b = None")
apply (auto intro: mreq_end2a mreq_endNone2)
done

lemma mreq_end3: "matching_rulePr x p \<noteq> None \<Longrightarrow>
                  matching_rulePr x (p@[b]) = matching_rulePr x (p)"
by (auto simp: mrconc)

lemma mrNoneMT[rule_format]: "r \<in> set p \<longrightarrow> matching_rulePr x p = None \<longrightarrow>
                              x \<notin> dom (Cp r)"
apply (induct p, simp_all)
done

lemma C_eq_RS2_mr: "matching_rulePr x (removeShadowRules2 p)= matching_rulePr x p"
proof (induct p)
 case Nil thus ?case by simp next
 case (Cons y ys) thus ?case
 proof (cases "ys = []")
  case True thus ?thesis by (cases y, simp_all) next
  case False thus ?thesis
   proof (cases y)
    case DenyAll thus ?thesis
by (metis DAAux matching_rulePr.simps(1) removeShadowRules2.simps(2))next
    case (DenyAllFromTo a b) thus ?thesis 
      proof (cases "DenyAllFromTo a b \<in> set ys")
        case True thus ?thesis using prems
          apply (cases "matching_rulePr x ys = None", simp_all)
sorry
        next
        case False thus ?thesis using prems
              apply simp sorry qed
    next
    case (AllowPortFromTo a b p) thus ?thesis using prems by simp
    next
    case (Conc a b) thus ?thesis by (simp add: Cons)
   qed
  qed
qed



lemma C_eq_None[rule_format]: "p \<noteq> []  --> matching_rulePr x p = None \<longrightarrow>
                               Cp (list2policy p) x = None"
apply (induct p, simp_all)
apply (case_tac "p=[]")
apply simp_all
apply (simp_all add: dom_def)
apply (rule impI)+
apply simp
by (metis CConcStart)


lemma C_eq_None2:
  "\<lbrakk>a \<noteq> []; b \<noteq> []; matching_rulePr x a = None; matching_rulePr x b = None\<rbrakk> \<Longrightarrow>
  (Cp (list2policy a)) x = (Cp (list2policy b)) x"
by (auto simp: C_eq_None)

lemma C_eq_RS2: "wellformed_policy1_strong p \<Longrightarrow> 
 Cp (list2policy (removeShadowRules2 p))= Cp (list2policy p)"
apply (rule ext)
apply (rule C_eq_if_mr_eq)
apply (rule C_eq_RS2_mr [symmetric], simp_all)
apply (metis wp1_alternative_not_mt wp1n_RS2)
done



lemma noneMTPrsubset[rule_format]: "noneMTPr a \<longrightarrow> set b \<subseteq> set a \<longrightarrow> noneMTPr b"
apply (induct b,simp_all)
by (metis dom_empty notMTnMT)

lemma noneMTPrRS2: "noneMTPr p \<Longrightarrow> noneMTPr (removeShadowRules2 p)"
by (auto simp: RS2Set noneMTPrsubset)

lemma CconcNone: "\<lbrakk>dom (Cp a) = {}; p \<noteq> []\<rbrakk> \<Longrightarrow>
                  Cp (list2policy (a # p)) x = Cp (list2policy p) x"
apply (case_tac "p = []", simp_all)
apply (case_tac "x\<in> dom (Cp (list2policy(p)))")
apply (metis CConcStart2 List.set.simps(1) bex_triv_one_point2 equals0D)
by (metis CConcStart2 foo28a)


lemma notMTpolicyimpnotMT[simp]: "notMTpolicyPr p \<Longrightarrow> p \<noteq> []"
by auto

lemma SR3nMT[rule_format]: "\<not> notMTpolicyPr p \<longrightarrow> removeShadowRules3Pr p = []"
by (induct p, simp_all)



definition remdups3 where "remdups3 l = rev (remdups (rev l))"

lemma remdups_subset[rule_format]: "x \<in> set (remdups3 p) \<longrightarrow> x \<in> set p"
apply (induct p,simp_all add: remdups3_def)
done


lemma noneMTPrrd[rule_format]: "noneMTPr p \<longrightarrow> noneMTPr (remdups3 p)"
by (metis nMTeqSet remdups3_def set_remdups set_rev)

lemma DARS3[rule_format]:"DenyAll \<notin> set p\<longrightarrow>DenyAll \<notin> set (removeShadowRules3Pr p)"
by (induct p, simp_all)

lemma DAnMT: "dom (Cp DenyAll) \<noteq> {}"
by (simp add: dom_def Cp.simps PolicyCombinators.PolicyCombinators)

lemma DAnMT2: "Cp DenyAll \<noteq> empty"
by (metis DAAux PLemmas(1) dom_eq_empty_conv empty_iff) 




lemma wp1n_RS3[rule_format,simp]: "wellformed_policy1_strong p \<longrightarrow>
                               wellformed_policy1_strong (removeShadowRules3Pr p)"
apply (induct p, simp_all)
apply (rule conjI| rule impI|simp)+
apply (drule mp,simp_all)
apply (case_tac a,simp_all)
apply (metis DAnMT)
apply (case_tac a,simp_all)
done

lemma AILRS3[rule_format,simp]: "all_in_list p l \<longrightarrow>
                                 all_in_list (removeShadowRules3Pr p) l"
by (induct p, simp_all)

lemma SCRS3[rule_format,simp]: "singleCombinators p \<longrightarrow>
                                singleCombinators(removeShadowRules3Pr p)"
apply (induct p, simp_all)
apply (case_tac "a", simp_all)
done


lemma RS3subset: "set (removeShadowRules3Pr p)  \<subseteq> set p "
by (induct p, auto)


lemma ANDRS3[simp]: "\<lbrakk>singleCombinators p; allNetsDistinct p\<rbrakk> \<Longrightarrow>
                     allNetsDistinct (removeShadowRules3Pr p)"
apply (rule_tac b = p in aNDSubset)
apply simp_all
apply (rule RS3subset)
done

lemma nlpaux: "x \<notin> dom (Cp a) \<Longrightarrow> Cp (a \<oplus> b) x = Cp b x"
by (metis Cp.simps(4) map_add_dom_app_simps(3))

lemma lpdom[rule_format]: "p \<noteq> [] \<longrightarrow> x \<notin> dom (Cp (list2policy (aa # p))) \<longrightarrow> x \<notin> dom (Cp (list2policy p))"
apply (induct p,simp_all)
apply (simp add: dom_def Cp.simps)
done


lemma notindom[rule_format]: "a \<in> set p \<longrightarrow>  x \<notin> dom (Cp (list2policy p)) \<longrightarrow>
                             x \<notin> dom (Cp a)"
apply (induct p)
apply simp_all
apply (rule conjI| rule impI)+
apply (metis CConcStartA)
apply (rule impI)+
apply (case_tac "p=[]")
apply simp_all
apply (drule mp)
apply simp_all
apply (rule lpdom)
apply simp_all
done

lemma "remdups3 [1::int,2,3,1,4] = X"
apply (simp add: remdups3_def)
oops

lemma "remdups [1::int,2,3,1,4] = X"
apply (simp add: remdups3_def)
oops

lemma "\<lbrakk>y =DenyAll; x\<in> dom (Cp a); (Cp a) x = Some (allow ());
Cp (list2policy (remdups [a,b])) x = Cp (list2policy [a,b]) x; [a,b] \<noteq> []; y \<in> set [a,b]\<rbrakk>
    \<Longrightarrow> Cp (list2policy [a,b]) x = Cp (list2policy (y # [a,b])) x"
apply simp
apply (case_tac "DenyAll=a")
apply simp_all
apply (simp add: PLemmas)
apply (simp add: PLemmas)
oops


lemma "Cp (list2policy (rev (remdups (rev ys)))) x = Cp (list2policy ys) x \<longrightarrow> ys \<noteq> [] \<longrightarrow>
    Cp (list2policy (rev (remdups (rev ys @ [y])))) x = Cp (list2policy (y # ys)) x"
apply (induct ys)
apply simp
apply simp
apply (rule impI)+
oops




lemma mr_tl[rule_format]: "ys \<noteq> [] \<longrightarrow>x \<notin> dom (Cp y) \<longrightarrow> 
  (Cp (list2policy (y#ys)) x = Cp (list2policy ys) x)"
apply (induct ys)
apply simp_all
apply (rule impI)
apply (simp add: PLemmas)
done

lemma remdups2_NMT[rule_format]: 
"p \<noteq> [] \<longrightarrow> remdups2 p \<noteq> []"
apply (induct p)
apply simp_all
done

lemma filter_all_Set[rule_format]: "ys \<noteq> [] \<longrightarrow> [ya\<leftarrow>ys . ya \<noteq> y] = [] \<longrightarrow>
                set ys = {y}"
apply (induct ys)
apply simp_all
apply (rule impI)+
apply (case_tac "ys=[]")
apply simp
apply simp
done



lemma filter_all[rule_format]: "ys \<noteq> [] \<longrightarrow> [x\<leftarrow>ys . x \<noteq> y] = [] \<longrightarrow>
                Cp y x = Cp (list2policy ys) x"
apply (induct ys)
apply simp_all
apply (rule impI)+
apply simp
apply (case_tac "ys=[]")
apply simp_all
apply (case_tac "x\<in>dom (Cp y)")
apply (metis CCponcEnd2 bex_triv_one_point2)
by (metis mr_tl)

lemma rd2_notindom[rule_format]: 
 "ys \<noteq> [] \<longrightarrow> x \<notin> dom (Cp y) \<longrightarrow> Cp (list2policy (remdups2 [x\<leftarrow>ys. x \<noteq> y])) x
 = (Cp (list2policy ys)) x"
apply (induct ys)
apply simp_all
apply (case_tac "ys=[]")
apply simp_all(*
apply (rule conjI)
apply (rule impI)+
apply simp
apply (case_tac "x \<in> dom (Cp a)")
apply (smt CCponcEnd2)
defer 1
apply (rule impI)+
apply simp
apply (case_tac "ys=[]")
apply simp_all
apply (rule sym)
apply (rule mr_isC
apply (subgoal_tac "Cp (list2policy (a # remdups2 [x\<leftarrow>ys . x \<noteq> y \<and> x \<noteq> a])) x =
                    Cp (list2policy (remdups2 [x\<leftarrow>ys . x \<noteq> y \<and> x \<noteq> a])) x")
apply (subgoal_tac "Cp (list2policy (a # ys)) x =
                    Cp (list2policy ys) x")
apply simp

apply (metis Conc_not_MT all_not_in_conv bot_empty_eq bot_fun_def emptyE eq_mem mem_def not_Cons_self)

apply (smt DAiniD butlast.simps(2) iD_charn_aux insertDenies.simps(1) insertDenies.simps(6) insertDeny.simps(1) l2p_aux2 last_ConsL noDA_char noDenyAll.simps(2) removeShadowRules1.simps(2) wellformed_policy1_strong.simps(5) wp1alternative_RS1)
by (metis DAiniD butlast.simps(2) iD_charn_aux insertDenies.simps(1) insertDenies.simps(6) insertDeny.simps(1) l2p_aux2 last_ConsL noDA_char noDenyAll.simps(2) removeShadowRules1.simps(2) wellformed_policy1_strong.simps(5) wp1alternative_RS1)

apply simp_all*)
oops


lemma fooaux[rule_format]: 
  "Cp (list2policy (remdups2 p)) x = Cp (list2policy p) x \<longrightarrow> p \<noteq> [] \<longrightarrow> x \<notin> dom (Cp y) \<longrightarrow>
     [z\<leftarrow>p . z \<noteq> y] \<noteq> [] \<longrightarrow>
    Cp (list2policy (remdups2 [ya\<leftarrow>p . ya \<noteq> y])) x = Cp (list2policy p) x"
apply (induct p)
apply simp_all
apply (case_tac "p=[]")
apply simp_all
apply (case_tac "a=y")
apply simp_all
apply (rule impI)+
apply simp
apply (metis mr_tl remdups2_NMT)
apply (rule impI)+
apply simp
apply (case_tac "x \<in> dom (Cp a)")
apply (smt CCponcEnd2)
sorry

lemma C_eq_rd[rule_format]: "p \<noteq> [] \<Longrightarrow>
                            Cp (list2policy (remdups2 p)) = Cp (list2policy p)"
apply (rule ext)
proof (induct p) 
  case Nil thus ?case by simp next
  case (Cons y ys) thus ?case
    proof (cases "ys = []")
      case True thus ?thesis  by simp next
      case False thus ?thesis using prems apply simp
       apply (cases "x \<in> dom (Cp y)")
       apply (metis CCponcEnd2)
       apply (case_tac "[ya\<leftarrow>ys . ya \<noteq> y] = []")
       apply simp_all
       apply (metis False domIff filter_all list2policyconc nlpaux)
       apply (subgoal_tac " Cp (list2policy (y # ys)) x =  (Cp (list2policy ys)) x")
       apply simp
       apply (subgoal_tac
      "Cp (list2policy (y # remdups2 [ya\<leftarrow>ys . ya \<noteq> y])) x =
       Cp (list2policy (remdups2 [ya\<leftarrow>ys . ya \<noteq> y])) x")
       apply simp
       defer 1
       apply (metis mr_tl remdups2_NMT)
       apply (metis False mr_tl)
       apply (rotate_tac -1,thin_tac "?S")
       apply (rotate_tac -1,thin_tac "?S")
       apply (rule fooaux)
       apply simp_all
       done
  qed
qed

lemma RS3nMT[rule_format]: "notMTpolicyPr p \<longrightarrow> notMTpolicyPr (removeShadowRules3Pr p)"
by (induct p,simp_all)


lemma nMT_domMT: "\<lbrakk>\<not> notMTpolicyPr p; p \<noteq> []\<rbrakk> \<Longrightarrow> r \<notin> dom (Cp (list2policy p))"
 proof (induct p)
   case Nil thus ?case by simp next
   case (Cons x xs) thus ?case apply simp
      apply (simp split: if_splits)
      apply (cases "xs = []")
      apply (simp_all add:dom_empty)
by (metis CconcNone domIff)
qed
            
lemma C_eq_RS3_aux[rule_format]: "notMTpolicyPr p \<Longrightarrow>
                  Cp (list2policy p) x = Cp (list2policy (removeShadowRules3Pr p)) x"
proof (induct p)
 case Nil thus ?case by simp next
 case (Cons y ys) thus ?case
   proof (cases "notMTpolicyPr ys")
     case True thus ?thesis using prems apply simp
     apply (rule conjI, rule impI, simp)
apply (metis CconcNone True notMTpolicyimpnotMT)
     apply (rule impI, simp)
     apply (cases "x \<in> dom (Cp ( y))")
apply (metis CCponcEnd2)
by (metis RS3nMT True mr_tl notMTpolicyimpnotMT)
     next 
     case False thus ?thesis using prems
        proof (cases "ys = []")
          case True thus ?thesis using prems by (simp) (rule impI, simp) next
          case False thus ?thesis using prems apply (simp)
            apply (rule conjI| rule impI| simp)+
            apply (subgoal_tac "removeShadowRules3Pr ys = []")
            apply simp_all
            apply (subgoal_tac "x \<notin> dom (Cp (list2policy ys))")
            apply (metis CConcStart CCponcEnd False domIff not_None_eq)
            apply (metis False `\<not> notMTpolicyPr ys` nMT_domMT)
            by (metis SR3nMT `\<not> notMTpolicyPr ys`)
        qed
     qed
qed       



lemma C_eq_id[rule_format]: "wellformed_policy1_strong p \<Longrightarrow>
                Cp(list2policy (insertDeny p)) = Cp (list2policy p)"
apply (rule ext)
apply (induct p)
apply simp_all
apply (case_tac "p=[]",simp_all)
apply (case_tac a,simp_all)
apply (rule impI)+
by (metis last_ConsR wp_last)

lemma C_eq_RS3: "notMTpolicyPr p \<Longrightarrow>
                 Cp(list2policy (removeShadowRules3Pr p)) = Cp (list2policy p)"
apply (rule ext)
by (erule C_eq_RS3_aux[symmetric])

lemma NMPcharn[rule_format]: "a \<in> set p\<longrightarrow> dom (Cp a) \<noteq> {} \<longrightarrow> notMTpolicyPr p"
by (induct p, simp_all)


lemma NMPrd[rule_format]: "notMTpolicyPr p \<longrightarrow> notMTpolicyPr (remdups2 p)"
apply (induct p, simp_all)
apply (rule conjI|rule impI)+
apply simp_all
sorry


lemma NMPRS3[rule_format]: "notMTpolicyPr p \<longrightarrow> notMTpolicyPr (removeShadowRules3Pr p)"
by (induct p, simp_all)


lemma NMPDA[rule_format]: "DenyAll \<in> set p \<longrightarrow> notMTpolicyPr p"
by (induct p, simp_all add: DAnMT)


lemma NMPiD[rule_format]: "notMTpolicyPr (insertDeny p)"
apply (insert DAiniD [of p])
apply (erule NMPDA)
done

lemma CpConc[rule_format]: "a \<noteq> [] \<longrightarrow> b \<noteq> [] \<longrightarrow> x \<notin> dom (Cp (list2policy a)) \<longrightarrow>
          Cp (list2policy (a @ b)) x =
          Cp (list2policy b) x"
apply (induct_tac a,simp_all)
apply (rule impI)+
apply simp
apply (case_tac "list=[]")
apply simp_all
apply (metis mr_tl)
by (metis CConcStartA append_is_Nil_conv lpdom mr_tl)


lemma list2policy2list[rule_format]: "Cp (list2policy(policy2list p)) = (Cp p)"
apply (rule ext)
apply (induct_tac p, simp_all)
apply (case_tac "x \<in> dom (Cp (Combinators1))") 
apply (metis Cdom2 CeqEnd domIff p2lNmt)
apply (subst CpConc)
apply simp_all
apply (metis p2lNmt)
apply (metis p2lNmt)
apply (simp_all add: PLemmas)
done

lemma distinct_remdups2 [iff]: "distinct (remdups2 xs)"
apply (induct xs) 
apply simp_all
apply auto
sorry



lemma AILrd[rule_format,simp]: "all_in_list p l \<longrightarrow> all_in_list (remdups2 p) l"
sorry

lemmas C_eq_Lemmas = noneMTPrRS2 noneMTPrrd SCp2l
                 wp1ID NMPiD wp1alternative_RS1 wp1n_RS2
              p2lNmt list2policy2list wellformed_policy3Pr_charn waux2 wp1_eq
              

lemmas C_eq_subst_Lemmas = C_eq_sorted C_eq_RS2 C_eq_rd C_eq_RS3 C_eq_id 

lemma C_eq_All_untilSorted: 
"\<lbrakk>DenyAll \<in> set (policy2list p);  all_in_list (policy2list p) l;
  allNetsDistinct (policy2list p)\<rbrakk> \<Longrightarrow>
  Cp(list2policy (sort (removeShadowRules2 (remdups2 (removeShadowRules3Pr
    (insertDeny (removeShadowRules1  (policy2list p)))))) l)) = Cp p"
apply (subst C_eq_sorted)
apply (simp_all add: C_eq_Lemmas)
apply (subst C_eq_RS2)
apply (simp_all add: C_eq_Lemmas) 
apply (subst C_eq_rd)
apply (simp_all add: C_eq_Lemmas)
apply (subst C_eq_RS3)
apply (simp_all add: C_eq_Lemmas)
apply (subst C_eq_id)
apply (simp_all add: C_eq_Lemmas)
done


(* or, even shorter *)

lemma C_eq_All_untilSorted_withSimps: 
"\<lbrakk>DenyAll \<in> set (policy2list p);  all_in_list (policy2list p) l;
 allNetsDistinct (policy2list p)\<rbrakk> \<Longrightarrow>
 Cp(list2policy (sort (removeShadowRules2 (remdups2 (removeShadowRules3Pr (insertDeny
   (removeShadowRules1  (policy2list p)))))) l)) = Cp p"
by (simp_all add: C_eq_Lemmas C_eq_subst_Lemmas)




lemma InDomConc[rule_format]: "p \<noteq> [] \<longrightarrow> x \<in> dom (Cp (list2policy (p))) \<longrightarrow>
                               x \<in>  dom (Cp (list2policy (a#p)))"
apply (induct p)
apply simp_all
apply (case_tac "p = []")
apply (simp_all add: dom_def Cp.simps)
done

lemma not_in_member[rule_format]: "member a b \<longrightarrow> x \<notin> dom (Cp b) \<longrightarrow> x \<notin> dom (Cp a)"
apply (induct b)
apply (simp_all add: dom_def Cp.simps)
done



lemma src_in_sdnets[rule_format]: "\<not> member DenyAll x \<longrightarrow> p \<in> dom (Cp x) \<longrightarrow>
                             subnetsOfAdr (src p) \<inter> (fst_set (sdnets x)) \<noteq> {}"
apply (induct rule: Combinators.induct)
apply simp
apply (simp add: fst_set_def subnetsOfAdr_def PLemmas)
apply (simp add: fst_set_def subnetsOfAdr_def PLemmas)
apply (rule impI)+
apply (simp add: fst_set_def)
apply (case_tac "p \<in> dom (Cp Combinators2)")
apply simp_all
apply (rule subnetAux)
apply assumption
apply (auto simp: PLemmas)
done

lemma dest_in_sdnets[rule_format]: "\<not> member DenyAll x \<longrightarrow> p \<in> dom (Cp x) \<longrightarrow>
                              subnetsOfAdr (dest p) \<inter> (snd_set (sdnets x)) \<noteq> {}"
apply (induct rule: Combinators.induct)
apply simp
apply (simp add: snd_set_def subnetsOfAdr_def PLemmas)
apply (simp add: snd_set_def subnetsOfAdr_def PLemmas)
apply (rule impI)+
apply (simp add: snd_set_def)
apply (case_tac "p \<in> dom (Cp Combinators2)")
apply simp_all
apply (rule subnetAux)
apply assumption
apply (auto simp: PLemmas)
done



lemma sdnets_in_subnets[rule_format]: "p\<in> dom (Cp x) \<longrightarrow> \<not> member DenyAll x \<longrightarrow>
        (\<exists> (a,b)\<in>sdnets x. a \<in> subnetsOfAdr (src p) \<and> b \<in> subnetsOfAdr (dest p))"
apply (rule Combinators.induct)
apply simp_all
apply (simp add: PLemmas subnetsOfAdr_def)
apply (simp add: PLemmas subnetsOfAdr_def)
apply (rule impI)+
apply simp
apply (case_tac "p \<in> dom (Cp (Combinators2))")
apply simp_all
apply (auto simp: PLemmas subnetsOfAdr_def)
done

lemma disjSD_no_p_in_both[rule_format]:   
 "\<lbrakk>disjSD_2 x y; \<not> member DenyAll x; \<not> member DenyAll y;  
   p \<in> dom (Cp x); p \<in> dom (Cp y)\<rbrakk> \<Longrightarrow> False"
apply (rule_tac A = "sdnets x" and B = "sdnets y" and D = "src p"
             and F = "dest p" in tndFalse)
by (auto simp: dest_in_sdnets src_in_sdnets sdnets_in_subnets disjSD_2_def)

lemma list2policy_eq: "zs \<noteq> [] \<Longrightarrow>
             Cp (list2policy (x \<oplus> y # z)) p = Cp (x \<oplus> list2policy (y # z)) p"
apply (metis Cp.simps(4) CConcStartaux C_eq_None C_eq_RS3 C_eq_if_mr_eq C_eq_rd 
             Cdom2 ConcAssoc domIff in_set_conv_decomp l2p_aux2 list.simps(1)
             list2policy.simps(2) list2policyconc map_add_None mrMTNone
             mrconcNone mreq_end3 mreq_endNone nlpaux not_Cons_self
             remdups2.simps(2) removeShadowRules3Pr.simps(2) self_append_conv2)
done



lemma x_in_dom_sep[rule_format]: "a \<in> dom (Cp (x \<oplus> list2policy (y # z)))
       \<longrightarrow> a \<in> dom (Cp (list2policy (separate (x \<oplus> y # z))))"
apply (rule separate.induct) back back
apply simp_all
apply (rule impI|simp)+
 apply (metis CConcStartA DAAux InDomConc bex_triv_one_point2 l2p_aux list.simps(2))
 apply (metis CConcStartA DAAux InDomConc bex_triv_one_point2 l2p_aux list.simps(2))(*
 apply (metis CConcStartA DAAux InDomConc bex_triv_one_point2 l2p_aux list.simps(2))
apply (rule impI|simp_all)
apply (case_tac "{v, va} = {vb, vc}",rule impI, simp_all)
apply (rule impI,simp_all)
apply (metis InDomConc list.simps(2) sepnMT)
apply (metis domIff list2policy_eq not_Cons_self)
apply (metis InDomConc bex_triv_one_point2 l2p_aux list.simps(3))
apply (case_tac "{v, va} = {vb, vc}",simp_all)
apply (metis domIff list2policy_eq not_Cons_self)
apply (metis InDomConc bex_triv_one_point2 l2p_aux list.simps(3))
apply (case_tac "{v, va} = first_bothNet vb ")
apply simp_all
apply (rule impI,simp_all)
apply (metis domIff list2policy_eq not_Cons_self)
apply (rule impI,simp_all)
apply (metis InDomConc list.simps(2) list2policyconc)
apply (metis domIff list2policy_eq not_Cons_self)


apply (metis domIff list2policy_eq not_Cons_self)
 apply (metis CConcStartA DAAux InDomConc bex_triv_one_point2 l2p_aux list.simps(2))
 apply (metis CConcStartA DAAux InDomConc bex_triv_one_point2 l2p_aux list.simps(2))
 apply (metis CConcStartA DAAux InDomConc bex_triv_one_point2 l2p_aux list.simps(2))
 apply (metis CConcStartA DAAux InDomConc bex_triv_one_point2 l2p_aux list.simps(2))
 apply (metis CConcStartA DAAux InDomConc bex_triv_one_point2 l2p_aux list.simps(2))
 apply (metis CConcStartA DAAux InDomConc bex_triv_one_point2 l2p_aux list.simps(2))
 apply (metis CConcStartA DAAux InDomConc bex_triv_one_point2 l2p_aux list.simps(2))
 apply (metis CConcStartA DAAux InDomConc bex_triv_one_point2 l2p_aux list.simps(2))
 apply (metis CConcStartA DAAux InDomConc bex_triv_one_point2 l2p_aux list.simps(2))

apply (metis RS1_DA bot_apply eq_mem ex_in_conv mem_def not_Cons_self singleCombinators.simps(1) singleCombinators.simps(2) singleCombinators.simps(3))
apply (induct z)
apply simp_all
apply (rule impI)
apply (case_tac "a \<in> dom (Cp (x \<oplus> list2policy (y # z)))")
apply simp_all
apply (metis Conc_not_MT all_not_in_conv bot_empty_eq bot_fun_def emptyE eq_mem mem_def not_Cons_self)
apply (rule impI)

apply simp
*)
sorry


lemma dom_sep[rule_format]: "x \<in> dom (Cp (list2policy p)) \<longrightarrow>
                             x \<in> dom (Cp (list2policy(separate p)))"
apply (rule separate.induct) back
apply simp_all
apply (rule impI)+
apply (metis C_eq_RS1 DAAux InDomConc RS1_DA list.simps(2) list2policy.simps(1) list2policy.simps(2))
apply (rule impI)+
apply (metis C_eq_RS1 DAAux InDomConc RS1_DA list.simps(2) list2policy.simps(1) list2policy.simps(2))
apply (rule impI)+(*
apply (smt CConcStartA C_eq_RS1 RS1_DA bar3 bex_triv_one_point2 l2p_aux list.simps(2) list2policy.simps(1) lpdom removeShadowRules1.simps(2) separate.simps(1))
 apply (smt CConcStartA InDomConc ball_one_point2 bar3 bex_triv_one_point2 equalityCE l2p_aux l2p_aux2 list.simps(3) list2policy.simps(1) mem_def separate.simps(14) separate.simps(15) sepnMT)
apply (smt CConcStartA Combinators.simps(12) InDomConc ball_one_point2 bar3 bex_triv_one_point2 equalityCE l2p_aux2 list2policy.simps(1) list2policy.simps(2) mem_def separate.simps(14) separate.simps(16) sepnMT)
apply (rule conjI |rule impI|simp_all)+
apply (metis domIff fBNsep foo8 list2policy_eq)
apply (metis domIff fBNsep foo8 list2policy_eq)

apply (metis domI domIff list2policy_eq not_None_eq option.simps(2))
apply (metis CConcStart CConcStartA CCponcEnd2 Cdom2 InDomConc domIff l2p_aux2 list.simps(3) list2policy.simps(2) mem_def nMT_domMT nlpaux notMTpolicyimpnotMT not_None_eq option.simps(2))

apply (metis Conc_not_MT all_not_in_conv bot_fun_def eq_mem mem_def not_Cons_self)

apply (metis Conc_not_MT all_not_in_conv bot_fun_def eq_mem mem_def not_Cons_self)
apply (thin_tac "False \<Longrightarrow> ?S")
apply (drule mp)
apply (case_tac "x \<in> dom (Cp (DenyAllFromTo v va))")
apply (metis CConcStartA domIff eq_Nil_appendI in_set_conv_decomp l2p_aux2
             list2policyconc not_Cons_self notindom)
apply (subgoal_tac "x \<in> dom (Cp (list2policy (y #z)))")
apply (metis CConcStartA Cdom2 InDomConc domIff l2p_aux2 list2policyconc nlpaux)
apply (subgoal_tac "x \<in> dom (Cp (list2policy ((DenyAllFromTo v va)#y#z)))")
apply (simp add: dom_def Cp.simps)
apply simp
apply simp
apply (rule impI)+
apply simp
apply (thin_tac "False \<Longrightarrow> ?S")
apply (case_tac "x \<in> dom (Cp (DenyAllFromTo v va))")
apply simp_all
apply (subgoal_tac "x \<in> dom (Cp (list2policy (y #z)))")
apply (metis InDomConc sepnMT list.simps(2))
apply (subgoal_tac "x \<in> dom (Cp (list2policy ((DenyAllFromTo v va)#y#z)))")
apply (simp add: dom_def Cp.simps)
apply simp
apply (rule impI | rule conjI)+
apply simp
apply (case_tac "x \<in> dom (Cp (AllowPortFromTo v va vb))")
apply (metis CConcStartA domIff eq_Nil_appendI in_set_conv_decomp l2p_aux2
            list2policyconc not_Cons_self notindom)
apply (subgoal_tac "x \<in> dom (Cp (list2policy (y #z)))")
apply simp
apply (metis CConcStartA Cdom2 InDomConc domIff l2p_aux2 list2policyconc nlpaux)
apply (simp add: dom_def Cp.simps)
apply (rule impI)+
apply simp
apply (case_tac "x \<in> dom (Cp (AllowPortFromTo v va vb))")
apply (metis CConcStartA)
apply (metis CConcStartA InDomConc domIff list.simps(1) list2policy.simps(2)
             nlpaux sepnMT)
apply (rule conjI | rule impI)+
apply simp
apply (thin_tac "False \<Longrightarrow> ?S")
apply (drule mp)
apply (case_tac "x \<in> dom (Cp ((v \<oplus> va)))")
apply (metis Cp.simps(4) CConcStartA ConcAssoc domIff eq_Nil_appendI
    in_set_conv_decomp list2policy2list list2policyconc notindom p2lNmt)
defer 1
apply simp_all
apply (rule impI)+
apply simp
apply (thin_tac "False \<Longrightarrow> ?S")
apply (case_tac "x \<in> dom (Cp ((v \<oplus> va)))")
apply (metis CConcStartA)
apply (drule mp)
apply (simp add: Cp.simps dom_def)
apply (metis InDomConc list.simps(2)sepnMT)
apply (subgoal_tac "x \<in> dom (Cp (list2policy (y#z)))")
apply (case_tac "x \<in> dom (Cp y)")
apply simp_all
apply (metis CConcStartA Cdom2 ConcAssoc domIff mem_def)
apply (metis InDomConc domIff l2p_aux2 list2policyconc nlpaux)
apply (case_tac "x \<in> dom (Cp y)")
apply simp_all
apply (metis InDomConc domIff l2p_aux2 list2policyconc nlpaux)
done*)

sorry

lemma domdConcStart[rule_format]: "   x \<in> dom (Cp (list2policy (a#b))) \<longrightarrow>
        x \<notin> dom (Cp (list2policy b))
       \<longrightarrow> x \<in> dom (Cp (a))"
apply (induct b, simp_all)
apply (auto simp: PLemmas)
apply (simp split: option.splits)
done

lemma sep_dom2_aux: "\<lbrakk>x \<in> dom (Cp (list2policy (a \<oplus> y # z)))\<rbrakk>
       \<Longrightarrow> x \<in> dom (Cp (a \<oplus> list2policy (y # z)))"
by (metis CConcStartA InDomConc domIff domdConcStart l2p_aux2 list.simps(2) 
          list2policy.simps(2) nlpaux)

lemma sep_dom2_aux2: 
"\<lbrakk>(x \<in> dom (Cp (list2policy (separate (y # z)))) \<longrightarrow>
    x \<in> dom (Cp (list2policy (y # z))));
   x \<in> dom (Cp (list2policy (a # separate (y # z))))\<rbrakk>
\<Longrightarrow> x \<in> dom (Cp (list2policy (a \<oplus> y # z)))"
by (metis CConcStartA Cdom2 domIff l2p_aux l2p_aux2 nlpaux)

lemma sep_dom2[rule_format]: 
 "x \<in> dom (Cp (list2policy (separate p))) \<longrightarrow> x \<in> dom (Cp (list2policy( p)))"
apply (rule separate.induct)
by (simp_all add: sep_dom2_aux sep_dom2_aux2)

lemma sepDom: "dom (Cp (list2policy p)) = dom (Cp (list2policy (separate p)))"
apply (rule equalityI)
by (rule subsetI, (erule dom_sep|erule sep_dom2))+

lemma C_eq_s_ext[rule_format]: "p \<noteq> [] \<longrightarrow>
                         Cp (list2policy (separate p)) a  = Cp (list2policy p) a "
(*
 proof (induct rule: separate.induct) 
  case goal1 thus ?case 
    apply simp
     done
  next
  case goal2 thus ?case 
     apply simp 
     apply (cases "y = []")
     apply simp_all (*
     apply (rule conjI|rule impI|simp)+
     apply (subst list2policyconc)
      apply (metis not_Cons_self sepnMT)
     apply (metis Cp.simps(4) CConcStartaux Cdom2 domIff)
     apply (rule conjI|rule impI|simp)+
     apply (erule list2policy_eq)
     apply (rule impI, simp)
     apply (subst list2policyconc) 
     apply (metis list.simps(2) sepnMT) 
     by (metis Cp.simps(4) CConcStartaux Cdom2 domIff)*) sorry
  next
  case goal3 thus ?case
  apply simp 
     apply (cases "z = []")(*
     apply simp_all
     apply (rule conjI|rule impI|simp)+
     apply (subst list2policyconc)
      apply (metis not_Cons_self sepnMT)
     apply (metis Cp.simps(4) CConcStartaux Cdom2 domIff)
     apply (rule conjI|rule impI|simp)+
     apply (erule list2policy_eq)
     apply (rule impI, simp)
     apply (subst list2policyconc) 
     apply (metis list.simps(2) sepnMT) 
     by (metis Cp.simps(4) CConcStartaux Cdom2 domIff)*) sorry
  next
  case goal4 thus ?case
  apply simp  (*
     apply (cases "z = []")
     apply simp_all
     apply (rule conjI|rule impI|simp)+
     apply (subst list2policyconc)
      apply (metis not_Cons_self sepnMT)
     apply (metis Cp.simps(4) CConcStartaux Cdom2 domIff)
     apply (rule conjI|rule impI|simp)+
     apply (erule list2policy_eq)
     apply (rule impI, simp)
     apply (subst list2policyconc) 
     apply (metis list.simps(2) sepnMT) 
     by (metis Cp.simps(4) CConcStartaux Cdom2 domIff)*) sorry
   next
  case goal5 thus ?case apply simp 
  apply (case_tac "{v, va} = {vb, vc} ") apply simp_all next
  case goal6 thus ?case by simp next
  case goal7 thus ?case by simp next
  case goal8 thus ?case by simp next
 qed*) sorry

lemma C_eq_s: "p \<noteq> [] \<Longrightarrow> Cp (list2policy (separate p)) = Cp (list2policy p)  "
apply (rule ext)
apply (rule C_eq_s_ext)
apply simp
done



lemmas C_eq_Lemmas_sep =
       C_eq_Lemmas sortnMT RS2_NMT notMTpolicyimpnotMT NMPrd NMPRS3 NMPiD


lemma C_eq_until_separated:
"\<lbrakk>DenyAll \<in> set (policy2list p); all_in_list (policy2list p) l;
  allNetsDistinct (policy2list p)\<rbrakk> \<Longrightarrow>
 Cp (list2policy (separate (sort (removeShadowRules2 (remdups2 (removeShadowRules3Pr
  (insertDeny (removeShadowRules1 (policy2list p)))))) l))) = Cp p"
apply (subst  C_eq_s)
apply (simp_all add: C_eq_Lemmas_sep)
apply (rule C_eq_All_untilSorted)
apply simp_all
done


lemma x_dom_conc: "x \<in> dom(Cp a) \<Longrightarrow> x \<in> dom (Cp (a \<oplus> b))"
apply (auto simp: PLemmas)
done


lemma domID3[rule_format]: "p \<noteq> [] \<and> x \<in> dom(Cp(list2policy p)) \<longrightarrow>
                           x \<in> dom (Cp(list2policy(insertDenies p)))"
apply (induct p,simp_all)
apply (rule impI)+
apply (case_tac p)
apply simp_all
apply (case_tac a,simp_all)
apply (simp add: Cp.simps)
apply (simp add: Cp.simps)
apply (erule x_dom_conc)
apply (case_tac "x \<in> dom (Cp (list2policy (aa # list)))")
apply simp_all
apply (case_tac a,simp_all)
apply (metis InDomConc idNMT list.simps(3))
apply (metis InDomConc idNMT list.simps(3))
apply (metis InDomConc idNMT list.simps(3))
apply (subgoal_tac "x \<in> dom (Cp a)")
apply (case_tac a,simp_all)
apply (metis CConcStartA mem_def x_dom_conc)
apply (metis CConcStartA mem_def x_dom_conc)
apply (metis CConcStartA mem_def x_dom_conc)
by (metis bar3 list2policy.simps(2))

   

lemma DA_is_deny: 
  "x \<in> dom (Cp (DenyAllFromTo a b \<oplus> DenyAllFromTo b a \<oplus> DenyAllFromTo a b)) \<Longrightarrow>
Cp (DenyAllFromTo a b\<oplus>DenyAllFromTo b a \<oplus> DenyAllFromTo a b) x = Some (deny ())"
apply (case_tac "x \<in> dom (Cp (DenyAllFromTo a b))")
apply (simp_all add: PLemmas)
apply (simp_all split: if_splits)
done

lemma iDdomAux[rule_format]: 
  "p \<noteq> [] \<longrightarrow> x \<notin> dom (Cp (list2policy p)) \<longrightarrow>
   x \<in> dom (Cp (list2policy (insertDenies p))) \<longrightarrow>
   Cp (list2policy (insertDenies p)) x = Some (deny ())"
 proof (induct p)
  case Nil thus ?case by simp
  next
  case (Cons y ys) thus ?case
    proof (cases y) 
      case DenyAll then show ?thesis by simp next
      case (DenyAllFromTo a b) then show ?thesis using prems
        apply simp
        apply (rule impI)+
        proof (cases "ys = []")
          case goal1 then show ?case apply simp  apply (auto simp: PLemmas)
apply (metis option.simps(2))
by (metis option.simps(2)) 
       next
          case goal2 then show ?case
            apply simp
            apply (drule mp)
            apply (metis DenyAllFromTo InDomConc goal2(3) goal2(5))
            apply (cases "x \<in> dom (Cp (list2policy (insertDenies ys)))")
            apply simp_all
            apply (subgoal_tac "Cp (list2policy (DenyAllFromTo a b \<oplus>
             DenyAllFromTo b a \<oplus> DenyAllFromTo a b#insertDenies ys)) x =
            Cp ((DenyAllFromTo a b \<oplus> DenyAllFromTo b a \<oplus> DenyAllFromTo a b)) x ")
            apply (auto simp: PLemmas split: option.splits decision.splits simp: if_splits Cp.simps)
            apply (rule DA_is_deny)
            apply (metis DenyAllFromTo domdConcStart goal2(4))
            apply (metis DenyAllFromTo l2p_aux2 list2policyconc nlpaux)
            done 
        qed
      next
      case (AllowPortFromTo a b c) then show ?thesis using prems
        proof (cases "ys = []")
          case goal1 then show ?case 
          apply simp
          apply (rule impI)+
       apply (subgoal_tac "x \<in> dom (Cp (DenyAllFromTo a b \<oplus> DenyAllFromTo b a))")
          apply (simp_all add: PLemmas)
          apply (simp split: if_splits) apply auto 
          done next
          case goal2 then show ?case
            apply simp
            apply (rule impI)+
            apply (drule mp)
            apply (metis AllowPortFromTo InDomConc goal2(4))
            apply (cases "x \<in> dom (Cp (list2policy (insertDenies ys)))")
            apply simp_all
            apply (metis AllowPortFromTo Cdom2 goal2(4) idNMT list2policyconc)
            apply (subgoal_tac "Cp (list2policy (DenyAllFromTo a b \<oplus>
                DenyAllFromTo b a \<oplus> AllowPortFromTo a b c#insertDenies ys)) x =
               Cp ((DenyAllFromTo a b \<oplus> DenyAllFromTo b a)) x ")
            apply simp
            defer 1 
            apply (metis AllowPortFromTo CConcStartA ConcAssoc goal2(4) idNMT
                         list2policyconc nlpaux)
            apply (simp add: PLemmas, simp split: if_splits) apply auto 
          done
         qed
      next
      case (Conc a b) then show ?thesis
 proof (cases "ys = []")
          case goal1 then show ?case 
            apply simp
            apply (rule impI)+
            apply (subgoal_tac "x \<in> dom (Cp (DenyAllFromTo (first_srcNet a)
         (first_destNet a) \<oplus> DenyAllFromTo (first_destNet a) (first_srcNet a)))")
            apply (simp_all add: PLemmas)
            apply (simp split: if_splits) apply auto 
            done next
          case goal2 then show ?case
            apply simp
            apply (rule impI)+
            apply (cases "x \<in> dom (Cp (list2policy (insertDenies ys)))")
           apply (metis Cdom2 Conc Cons InDomConc goal2(2) idNMT list2policyconc)
            apply (subgoal_tac "Cp (list2policy (DenyAllFromTo (first_srcNet a) 
            (first_destNet a) \<oplus> DenyAllFromTo (first_destNet a) (first_srcNet a)
            \<oplus> a\<oplus> b#insertDenies ys)) x =
            Cp ((DenyAllFromTo (first_srcNet a) (first_destNet a)  \<oplus>
            DenyAllFromTo (first_destNet a)  (first_srcNet a) \<oplus> a\<oplus> b)) x ")
            apply simp
            defer 1 
            apply (metis Conc l2p_aux2 list2policyconc nlpaux)
            apply (subgoal_tac "Cp ((DenyAllFromTo (first_srcNet a)
            (first_destNet a) \<oplus> DenyAllFromTo (first_destNet a)
            (first_srcNet a) \<oplus> a\<oplus> b)) x = Cp ((DenyAllFromTo (first_srcNet a)
     (first_destNet a)  \<oplus> DenyAllFromTo (first_destNet a)  (first_srcNet a))) x ")
            apply simp
            defer 1 
            apply (metis CConcStartA Conc ConcAssoc nlpaux)
            apply (simp add: PLemmas, simp split: if_splits) apply auto 
          done
        qed
    qed
qed         

lemma iD_isD[rule_format]: "p \<noteq> [] \<longrightarrow> x \<notin> dom (Cp (list2policy p))
          \<longrightarrow> Cp (DenyAll \<oplus> list2policy (insertDenies p)) x = Cp DenyAll x"
apply (case_tac "x \<in> dom (Cp (list2policy (insertDenies p)))")
apply (rule impI)+
apply (metis Cp.simps(1) deny_all_def iDdomAux Cdom2)
apply (rule impI)+
apply (subst nlpaux)
apply simp_all
done


lemma inDomConc:"\<lbrakk> x\<notin>dom (Cp a); x\<notin>dom (Cp (list2policy p))\<rbrakk> \<Longrightarrow>
                 x \<notin> dom (Cp (list2policy(a#p)))"
by (metis domdConcStart)

lemma domsdisj[rule_format]: "p \<noteq> [] \<longrightarrow> (\<forall> x s. s \<in> set p \<and> x \<in> dom (Cp A) \<longrightarrow> 
                             x \<notin> dom (Cp s)) \<longrightarrow> y \<in> dom (Cp A) \<longrightarrow>
                             y \<notin> dom (Cp (list2policy p))"
apply (induct p)
apply simp
apply (case_tac "p = []")
apply simp
apply (rule_tac x = y in spec)
apply (simp add: split_tupled_all)
apply (rule impI)+
apply (rule inDomConc)
apply (drule_tac x = y in spec, drule_tac x = a in spec)
apply auto
done

lemma isSepaux:
  "\<lbrakk>p \<noteq> []; noDenyAll (a#p); separated (a # p);
   x \<in> dom (Cp (DenyAllFromTo (first_srcNet a) (first_destNet a) \<oplus>
   DenyAllFromTo (first_destNet a) (first_srcNet a) \<oplus> a))\<rbrakk> \<Longrightarrow>
   x \<notin> dom (Cp (list2policy p))"
apply (rule_tac A = "(DenyAllFromTo (first_srcNet a) (first_destNet a) \<oplus>
             DenyAllFromTo (first_destNet a) (first_srcNet a) \<oplus> a)" in domsdisj)
apply simp_all
apply (rule notI)
apply (rule_tac p = xa and x ="(DenyAllFromTo (first_srcNet a) (first_destNet a) 
                \<oplus> DenyAllFromTo (first_destNet a) (first_srcNet a) \<oplus> a)" and
                y = s in disjSD_no_p_in_both)
apply simp_all
apply (simp add: disjSD_2_def)
apply (rule allI)+
apply (metis first_isIn tNDComm twoNetsDistinct_def)
apply (metis noDA)
done



lemma noneMTPrsep[rule_format]: "noneMTPr p \<longrightarrow> noneMTPr (separate p)"
apply (rule separate.induct) back
apply (simp_all add: Cp.simps map_add_le_mapE map_le_antisym)
done



lemma dom_id: 
  "\<lbrakk>noDenyAll (a#p); separated (a#p); p \<noteq> []; x \<notin> dom (Cp (list2policy p));
   x \<in> dom (Cp (a))\<rbrakk>
       \<Longrightarrow> x \<notin> dom (Cp (list2policy (insertDenies p)))"
apply (rule_tac a = a in isSepaux)
apply simp_all
apply (rule idNMT)
apply simp
apply (rule noDAID)
apply simp
apply (rule conjI)
apply (rule allI)
apply (rule impI)
apply (rule id_aux4)
apply simp_all
apply (rule sepNetsID)
apply simp_all
apply (metis noDA1eq)
apply (simp add: Cp.simps)
done

lemma C_eq_iD_aux2[rule_format]: 
 "noDenyAll1 p \<longrightarrow>
separated p\<longrightarrow>
p \<noteq> []\<longrightarrow>
x \<in> dom (Cp (list2policy p))\<longrightarrow>
Cp(list2policy (insertDenies p)) x = Cp(list2policy p) x"
proof (induct p)
case Nil thus ?case by simp 
next
case (Cons y ys)  thus ?case using prems
 proof (cases y)
 case DenyAll thus ?thesis using prems apply simp
   apply (case_tac "ys = []")
   apply simp_all
   apply (case_tac "x \<in> dom (Cp (list2policy ys))") 
   apply simp_all
apply (metis Cdom2 Combinators.simps(1) DenyAll FWCompilation.member.simps(3) 
bar3 domID idNMT in_set_conv_decomp insert_absorb insert_code list2policyconc
nMT_domMT noDA noDA1eq noDenyAll.simps(1) notMTpolicyimpnotMT notindom)
apply (metis DenyAll iD_isD idNMT list2policyconc nlpaux)
   done
 next
 case (DenyAllFromTo a b) thus ?thesis using prems apply simp
   apply (rule impI|rule allI|rule conjI|simp)+
   apply (case_tac "ys = []")
   apply simp_all
   apply (metis Cdom2 ConcAssoc DenyAllFromTo)
   apply (case_tac "x \<in> dom (Cp (list2policy ys))")
   apply simp_all
   apply (drule mp)
   apply (metis noDA1eq)
   apply (case_tac "x \<in> dom (Cp (list2policy (insertDenies ys)))")
   apply (metis Cdom2 DenyAllFromTo idNMT list2policyconc)
   apply (metis domID)
   apply (case_tac "x \<in> dom (Cp (list2policy (insertDenies ys)))")
   apply (subgoal_tac "Cp (list2policy (DenyAllFromTo a b \<oplus> DenyAllFromTo b a \<oplus>
                       DenyAllFromTo a b # insertDenies ys)) x = Some (deny ())")
   apply simp_all
   apply (subgoal_tac "Cp (list2policy (DenyAllFromTo a b # ys)) x =
                       Cp ((DenyAllFromTo a b)) x")
   apply (simp add: PLemmas, simp split: if_splits)
   apply (metis list2policyconc nlpaux)
   apply (metis Cdom2 DenyAllFromTo iD_isD iDdomAux idNMT list2policyconc mem_def)
apply (metis Cdom2 DenyAllFromTo domIff domdConcStart idNMT list2policyconc nlpaux)
   done
 next
 case (AllowPortFromTo a b c) thus ?thesis using prems apply simp
   apply (rule impI|rule allI|rule conjI|simp)+
   apply (case_tac "ys = []")
   apply simp_all
   apply (metis Cdom2 ConcAssoc AllowPortFromTo)
   apply (case_tac "x \<in> dom (Cp (list2policy ys))")
   apply simp_all
   apply (drule mp)
   apply (metis noDA1eq)
   apply (case_tac "x \<in> dom (Cp (list2policy (insertDenies ys)))")
   apply (metis Cdom2 AllowPortFromTo idNMT list2policyconc)
   apply (metis domID)
   apply (subgoal_tac "x \<in> dom (Cp (AllowPortFromTo a b c))")
   apply (case_tac "x \<notin> dom (Cp (list2policy (insertDenies ys)))")
   apply simp_all
   apply (metis AllowPortFromTo Cdom2 ConcAssoc l2p_aux2 list2policyconc nlpaux)
   apply (metis AllowPortFromTo Combinators.simps(6) FWCompilation.member.simps(4) 
                dom_id noDenyAll.simps(1) separated.simps(1))
   apply (metis AllowPortFromTo domdConcStart)
   done
 next
 case (Conc a b) thus ?thesis using prems apply simp
   apply (rule impI|rule allI|rule conjI|simp)+
   apply (case_tac "ys = []")
   apply simp_all
   apply (metis Cdom2 ConcAssoc Conc)
   apply (case_tac "x \<in> dom (Cp (list2policy ys))")
   apply simp_all
   apply (drule mp)
   apply (metis noDA1eq)
   apply (case_tac "x \<in> dom (Cp (a \<oplus> b))")
   apply (case_tac "x \<notin> dom (Cp (list2policy (insertDenies ys)))")
   apply simp_all
   apply (subst list2policyconc)
   apply (rule idNMT, simp)
   apply (metis domID)
   apply (metis Cdom2 Conc idNMT list2policyconc)
   apply (metis CCponcEnd2 CConcStartA Cdom2 Conc aux0_4 domID domIff idNMT
     in_set_conv_decomp l2p_aux2 list2policyconc nMT_domMT
     notMTpolicyimpnotMT not_Cons_self notindom)
   apply (case_tac "x \<in> dom (Cp (a \<oplus> b))")
   apply (case_tac "x \<notin> dom (Cp (list2policy (insertDenies ys)))")
   apply simp_all
   apply (subst list2policyconc)
   apply (rule idNMT, simp)
   apply (metis Cdom2 Conc ConcAssoc list2policyconc nlpaux)
   apply (metis Conc FWCompilation.member.simps(1) dom_id 
                noDenyAll.simps(1) separated.simps(1))
   apply (metis Conc domdConcStart)
   done
 qed
qed

lemma C_eq_iD: "\<lbrakk>separated p; noDenyAll1 p; wellformed_policy1_strong p\<rbrakk>  \<Longrightarrow> 
 Cp (list2policy (insertDenies p)) = Cp (list2policy p)"
apply (rule ext)
apply (rule C_eq_iD_aux2)
apply simp_all 
apply (subgoal_tac "DenyAll \<in> set p")
apply (metis CConcStartA DAAux wp1n_tl)
apply (erule wp1_aux1aa)
done


lemmas CLemmas = noneMTPrsep nMTSort noneMTPrRS2 noneMTPrrd nMTRS3 separatedSep 
  noDAsort nDASC wp1_eq WP1rd wp1ID SC2 SCrd SCRS3 SCRiD SC1 SCp2l aND_sort 
  SC2 SCrd aND_RS2 ANDRS3 wellformed1_sorted wp1ID ANDiD  ANDrd SC1 aND_RS1 SC3 
  ANDSep OTNSEp OTNSC noDA1sep wp1_alternativesep wellformed1_alternative_sorted  
   distinct_RS2 

lemmas C_eqLemmas_id = C_eq_Lemmas_sep CLemmas OTNSEp NC2Sep NetsCollectedSep 
                        NetsCollectedSort separatedNC

lemma C_eq_Until_InsertDenies: "\<lbrakk>DenyAll \<in> set (policy2list p); all_in_list 
                          (policy2list p) l; allNetsDistinct (policy2list p)\<rbrakk> \<Longrightarrow> 
Cp (list2policy ((insertDenies (separate (sort (removeShadowRules2 (remdups2
(removeShadowRules3Pr (insertDeny (removeShadowRules1 (policy2list p)))))) l))))) =
                                Cp p"
apply (subst C_eq_iD)
apply (simp_all add: C_eqLemmas_id)
apply (rule C_eq_until_separated)
apply simp_all
done


lemma C_eq_RD_aux[rule_format]: "Cp (p) x = Cp (removeDuplicates p) x" 
apply (induct p)
apply simp_all
apply (rule conjI, rule impI)
apply (metis Cdom2 domIff nlpaux not_in_member)
apply (metis Cp.simps(4) CConcStartaux Cdom2 domIff)
done

lemma C_eq_RAD_aux[rule_format]: 
  "p \<noteq> []  \<longrightarrow> Cp (list2policy p) x = Cp (list2policy (removeAllDuplicates p)) x"
apply (induct p)
apply simp_all
apply (case_tac "p = []")
apply simp_all
apply (metis C_eq_RD_aux)
apply (subst list2policyconc)
apply simp
apply (case_tac "x \<in> dom (Cp (list2policy p))")
apply (subst list2policyconc)
apply (rule rADnMT)
apply simp
apply (subst Cdom2)
apply simp
apply (drule sym)
apply (subst Cdom2)
apply (simp add: dom_def)
apply simp
apply (drule sym)
apply (subst nlpaux)
apply simp
apply (subst list2policyconc)
apply (rule rADnMT)
apply simp
apply (subst nlpaux)
apply (simp add: dom_def)
apply (rule C_eq_RD_aux)
done

lemma C_eq_RAD: 
  "p \<noteq> []  \<Longrightarrow> Cp (list2policy p) = Cp (list2policy (removeAllDuplicates p)) "
apply (rule ext)
apply (erule C_eq_RAD_aux)
done



lemma C_eq_compile: 
"\<lbrakk>DenyAll \<in> set (policy2list p); all_in_list (policy2list p) l; 
 allNetsDistinct (policy2list p)\<rbrakk> \<Longrightarrow> 
Cp (list2policy (removeAllDuplicates (insertDenies (separate (sort 
(removeShadowRules2 (remdups2 (removeShadowRules3Pr (insertDeny 
 (removeShadowRules1 (policy2list p)))))) l))))) = Cp p"
apply (subst C_eq_RAD[symmetric])
apply (rule idNMT)
apply (simp add: C_eqLemmas_id)
apply (rule C_eq_Until_InsertDenies) 
apply simp_all
done



lemma C_eq_normalize: 
"\<lbrakk>DenyAll \<in> set (policy2list p); 
 allNetsDistinct (policy2list p);
all_in_list (policy2list p) (Nets_List p)\<rbrakk> \<Longrightarrow> 
Cp (list2policy (normalizePr p)) = Cp p"
apply (simp add: normalizePr_def)
apply (rule C_eq_compile)
apply simp_all
done




lemma domSubset3: "dom (Cp (DenyAll \<oplus> x)) = dom (Cp (DenyAll))"
apply (simp add: PLemmas split_tupled_all split: option.splits)
done



lemma domSubset4: "dom (Cp (DenyAllFromTo x y \<oplus> DenyAllFromTo y x \<oplus> AllowPortFromTo x y dn)) = 
                  dom (Cp (DenyAllFromTo x y \<oplus> DenyAllFromTo y x))"
apply (simp add: PLemmas )
apply (simp split: option.splits decision.splits)
apply auto
done

lemma domSubset5: 
 "dom (Cp (DenyAllFromTo x y \<oplus> DenyAllFromTo y x \<oplus> AllowPortFromTo y x dn)) = 
                  dom (Cp (DenyAllFromTo x y \<oplus> DenyAllFromTo y x))"
apply (simp add: PLemmas)
apply (simp split: option.splits decision.splits)
apply auto
done



lemma domSubset1: "dom (Cp (DenyAllFromTo one two \<oplus> DenyAllFromTo two one \<oplus> AllowPortFromTo one two dn \<oplus> x)) = 
                  dom (Cp (DenyAllFromTo one two \<oplus> DenyAllFromTo two one \<oplus> x))"
apply (simp add: PLemmas)
apply (simp split: option.splits decision.splits)
apply (simp add: allow_all_def deny_all_def)
apply auto
done

lemma domSubset2: 
 "dom (Cp (DenyAllFromTo one two \<oplus> DenyAllFromTo two one \<oplus> AllowPortFromTo two one dn \<oplus> x)) = 
                  dom (Cp (DenyAllFromTo one two \<oplus> DenyAllFromTo two one \<oplus> x))"
apply (simp add: PLemmas)
apply (simp split: option.splits decision.splits)
apply (simp add: allow_all_def deny_all_def)
apply auto
done


lemma ConcAssoc2: "Cp (X \<oplus> Y \<oplus> ((A \<oplus> B) \<oplus> D)) = Cp (X \<oplus> Y \<oplus> A \<oplus> B \<oplus> D)"
apply (simp add: Cp.simps)
done


lemma RS3_NMT[rule_format]: "DenyAll \<in> set p \<longrightarrow>
    removeShadowRules3Pr p \<noteq> []"
apply (induct_tac p) 
apply (simp_all)
apply (simp_all add: PLemmas deny_all_def)
done

lemma norm_notMT: "DenyAll \<in> set (policy2list p) \<Longrightarrow> normalizePr p \<noteq> []"
apply (simp add: normalizePr_def)
apply (rule rADnMT)
apply (rule idNMT)
apply (rule sepnMT)
apply (rule sortnMT)
apply (rule RS2_NMT)
apply (rule remdups2NMT) 
apply (rule RS3_NMT)
apply (rule DAiniD)
done



lemma domDA: "dom (Cp (DenyAll \<oplus> A)) = dom (Cp (DenyAll))"
apply (rule domSubset3)
done


lemmas domain_reasoningP = domDA ConcAssoc2 domSubset1 domSubset2 
 domSubset3 domSubset4  domSubset5 domSubsetNAT coerc_assoc






lemma list2policyR_Start[rule_format]: "p \<in> dom (Cp a) \<longrightarrow>
                 Cp (list2policyR (a # list)) p = Cp a p"
apply (rule list2policyR.induct) back
apply (simp_all add: Cp.simps)
apply (simp_all add: Cp.simps dom_def map_add_def)
apply (simp split: option.splits)
apply (simp split: option.splits)
done


lemma list2policyR_End: "p \<notin> dom (Cp a) \<Longrightarrow>
        Cp (list2policyR (a # list)) p = (Cp a \<Oplus> list2policyP (Comb2PolList list Cp)) p"
apply (rule list2policyR.induct)
apply simp_all
apply (simp_all add: Cp.simps dom_def map_add_def)
apply (simp split: option.splits)
done


lemma l2polR_eq_el[rule_format]: "N \<noteq> [] \<longrightarrow>
 Cp( list2policyR N) p =  (list2policyP (Comb2PolList N Cp)) p"
apply (induct_tac N)
apply simp_all
apply (case_tac "p \<in> dom (Cp a)")
apply (simp add: domStart) 
apply (rule list2policyR_Start)
apply simp_all
apply (rule list2policyR.induct)
apply simp_all
apply (simp_all add: Cp.simps dom_def map_add_def)
apply (simp split: option.splits)
done


lemma l2polR_eq: "N \<noteq> [] \<Longrightarrow>
 Cp( list2policyR N) =  (list2policyP (Comb2PolList N Cp))"
by (rule ext, erule l2polR_eq_el)



lemma list2policys_eq_el[rule_format]: 
 "Filter \<noteq> []  \<longrightarrow>  Cp (list2policyR Filter) p =  Cp (list2policy (rev Filter)) p"
apply (induct_tac Filter)
apply simp_all
apply (case_tac "list = []")
apply simp_all
apply (case_tac "p \<in> dom (Cp a)")
apply simp_all
apply (rule list2policyR_Start)
apply simp_all
apply (subgoal_tac "Cp (list2policyR (a # list)) p = Cp (list2policyR list) p")
apply (subgoal_tac "Cp (list2policy (rev list @ [a])) p = Cp (list2policy (rev list)) p")
apply simp
apply (rule CConcStart2)
apply simp
apply simp
apply (thin_tac "?S")
apply (case_tac list,simp_all)
apply (simp_all add: Cp.simps dom_def map_add_def)
done

lemma list2policys_eq: 
 "Filter \<noteq> []  \<Longrightarrow>
  Cp (list2policyR Filter) =  Cp (list2policy (rev Filter))"
by (rule ext, erule list2policys_eq_el)


lemma list2policys_eq_sym: 
 "Filter \<noteq> []  \<Longrightarrow>
  Cp (list2policyR (rev Filter)) =  Cp (list2policy Filter)"
by (metis list2policys_eq rev_is_Nil_conv rev_rev_ident)


lemma p_eq[rule_format]: "p \<noteq> [] \<longrightarrow> 
 list2policyP (Comb2PolList (rev p) Cp) = Cp (list2policy p)"
by (metis l2polR_eq list2policys_eq_sym rev.simps(1) rev_rev_ident)


lemma p_eq2[rule_format]: "normalizeCp x \<noteq> [] \<longrightarrow> 
  Cp (list2policy (normalizeCp x)) = Cp x \<longrightarrow>
 list2policyP (Comb2PolList (rev (normalizeCp x)) Cp) = Cp x"
apply (simp add: p_eq)
done

lemma list2listNMT[rule_format]: "x \<noteq> [] \<longrightarrow> Comb2PolList x sem \<noteq> []"
apply (case_tac x)
apply simp_all
done


lemma Norm_Distr2: 
 "r o_f ((P \<Otimes>\<^sub>2 (list2policyP Q)) o d) = 
  (list2policyP ((P \<Otimes>\<^sub>L Q) (op \<Otimes>\<^sub>2) r d))"
apply (rule ext, rule Norm_Distr)
done


lemma NATDistr: "\<lbrakk>N \<noteq> []; F = Cp (list2policyR N)\<rbrakk> \<Longrightarrow> 
  ((\<lambda> (x,y). x) o_f ((NAT \<Otimes>\<^sub>2 F) o (\<lambda> x. (x,x)))  = 
   (list2policyP (  ((NAT \<Otimes>\<^sub>L (Comb2PolList N Cp)) (op \<Otimes>\<^sub>2) 
    (\<lambda> (x,y). x) (\<lambda> x. (x,x))))))"
apply simp
apply (simp add: l2polR_eq) 
apply (rule Norm_Distr2)
done




text{* As an example, how this theorems can be used for a concrete
normalisation instantiation. *}

lemma normalizeNAT: "\<lbrakk>DenyAll \<in> set (policy2list Filter);
 allNetsDistinct (policy2list Filter); 
 all_in_list (policy2list Filter) (Nets_List Filter)\<rbrakk> \<Longrightarrow> 
 ((\<lambda> (x,y). x) o_f (((NAT \<Otimes>\<^sub>2 (Cp Filter)) o (\<lambda>x. (x,x)))))  = 
  list2policyP ((NAT \<Otimes>\<^sub>L (Comb2PolList (rev (normalizePr (Filter))) Cp)) (op \<Otimes>\<^sub>2) (\<lambda> (x,y). x) (\<lambda> x. (x,x)))"
apply (rule NATDistr)
apply simp_all
apply (metis normalizePr_def norm_notMT)
by (metis C_eq_normalize list2policys_eq_sym norm_notMT)





lemma domDA1: "dom (Cp (DenyAll \<oplus> P)) = UNIV"
apply (simp add: PLemmas)
apply (auto split: option.splits simp: deny_all_def)
done


lemma AllowNMT: "\<lbrakk>x \<noteq> {}; y \<noteq> {}\<rbrakk>  \<Longrightarrow> 
 dom (Cp (AllowPortFromTo {{(a, b, c). a \<in> x}} {{(a, b, c). a \<in> y}} (p,i))) \<noteq> {}"
apply (simp add: PLemmas)
apply auto
done


lemma setDistinct2: "\<lbrakk>x \<noteq> y\<rbrakk> \<Longrightarrow>
 {(a, b). a \<in> x} \<noteq> {(a, b). a \<in> y}"
apply auto
done


lemma setDistinct1: "\<lbrakk>x \<noteq> y\<rbrakk> \<Longrightarrow>
 {(a, b, c). a \<in> x} \<noteq> {(a, b, c). a \<in> y}"
apply auto
done
 


lemma setDistinct: "\<lbrakk>x \<in> a; x \<notin> b\<rbrakk> \<Longrightarrow> a \<noteq> b"
apply auto
done

lemma setDistinct3: "\<lbrakk>x \<noteq> y\<rbrakk> \<Longrightarrow>
 {{(a, b, c). a \<in> x}} \<noteq> {{(a, b, c). a \<in> y}}"
apply auto
done



lemma setDistinct4: "\<lbrakk>(a::int) \<noteq> x; a < b; x < y\<rbrakk>
                       \<Longrightarrow> {a..b} \<noteq> {x..y}"
apply (case_tac "a < x")
apply simp_all
apply (rule_tac x = a in setDistinct)
apply simp_all
apply (rule not_sym)
apply (rule_tac x = x in setDistinct)
apply simp_all
done


end


